/*
Released under GPL, written by Caolan.McNamara@ul.ie.

Copyright (C) 1998 
	Caolan McNamara

Real Life: Caolan McNamara           *  Doing: MSc in HCI
Work: Caolan.McNamara@ul.ie          *  Phone: +353-61-202699
URL: http://skynet.csn.ul.ie/~caolan *  Sig: an oblique strategy
How would you have done it?
*/

/*warning: this software requires laola's lls to be installed*/

char *version="mswordview 0.1.0";

/*

this code is often all over the shop, being more of an organic entity
that a carefully planed piece of code, so no laughing there at the back!

and send me patches by all means, but think carefully before sending me
a patch that doesnt fix a bug or add a feature but instead just changes
the style of coding, i.e no more thousand line patches that fix my 
indentation.

*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include "config.h"
#include "roman.h"
#include "utf.h"

#ifndef PATH_MAX
#define PATH_MAX 255 /*seems a reasonable figure*/
#endif

#define U32 unsigned int
#define U16 unsigned short
#define S16 signed short
#define U8 unsigned char

/*
#define NORMAL 20
*/
int NORMAL=20;

struct node
	{
	char streamname[255];
	char filename[PATH_MAX];
	struct node *next;
	int level;
	};

typedef struct node olestream;

struct tchp
    {
	unsigned short istd;
    U8 fBold;
    U8 fItalic;
	U16 ascii_font;
	U16 eastfont;
	U16 noneastfont;
	U16 fontsize; /*half points*/
	U8 supersubscript;
	U16 fontcode;
	U16 fontspec;
	char *color;
	U16 underline;
	U8 fSpec;
    };

typedef struct tchp chp;

struct tlist_def
	{
	U16 *list_string;	
	int len;
	int begin_no;
	int no_type;
	U32 id;
	chp achp;
	struct tlist_def *sub_def_list;
	};

typedef struct tlist_def list_def;

struct tanld
	{
	U8 nfc;
	U8 cxchTextBefore;
	U8 cxchTextAfter;
	U8 flags1;
	U8 flags2;
	U8 flags3;
	U16 ftc;
	U16 hps;
	U16 startat;
	U16 rgxch[32];
	};

typedef struct tanld anld;


struct ttap
	{
	int tablewidth;
	S16 cellwidth[65];
	int cell_no;
	};

typedef struct ttap tap;

struct tpap
    {
    unsigned short istd;
    U8 fInTable;
    U8 fTtp;
	U8 tableflag;
	int ilvl; /*list level, 0 to 8*/
	long ilfo; /*list index*/
	/*link to list information*/
	list_def *list_data;
	anld ouranld;
	tap ourtap;
    };

typedef struct tpap pap;


struct field_pro
	{
	U32 *cps;
	U8 *flds;
	int no;
	};

typedef struct field_pro field_info;

struct tlist_info
	{
	/*
	now this is very hairy, i not sure how this is supposed to work
	so lists are a bit tentitive, basically theres no many things you 
	*can* do with lists, but hopefully this will sort out whether they
	are bulleted or enumerated, and ignore all sorts of shite like
	what kind of bullet were talking about, and whether some list
	items are numbered etc etc
	*/
	U8 *array;
	int count;
	int nooflsts;
	U32 *o_lst_ids;
	list_def *o_list_def;
	U8 *level;

	U8 *lstarray;
	int lstcount;
	int nooflfos;
	U32 *lst_ids;
	list_def *a_list_def;
	int *overridecount;
	};

typedef struct tlist_info list_info;

struct tsprm
	{
	U8 *list;
	struct tsprm *next;
	int len;
	};

typedef struct tsprm Sprm;



struct tstyle
	{
	pap thepap;
	chp thechp;
	};

typedef struct tstyle style;

struct ttextportions
	{
	U32 fcMin;
	U32 fcMac;
	U32 ccpText;
	U32 ccpFtn;
	U32 ccpHdd;
	U32 fcPlcfhdd;
	U32 lcbPlcfhdd;
	U32 *headercplist;
	U8 headercpno;
	U32 fndref_no;
	U32 fndtxt_no;
	U32 *fndRef;
	U16 *fndFRD;
	U32 *fndTxt;
	int list_footnotes[256];
	int list_foot_no;
	};

typedef struct ttextportions textportions;

struct tffn
	{
	char name[65];
	U8 chs;
	struct tffn *next;
	};

typedef struct tffn ffn;

/*ok i got impatient*/
int inunderline = 0;
int inbold = 0;
int inah1= 0;
int initalic = 0;
int inafont= 0;
int pagenumber=1;
int sectionpagenumber=1;
int insuper = 0;
int insub = 0;
int inatable=0;
int inarow=0;
int inacell=0;
int inalist = 0;

S16 lastcellwidth[65];
S16 lastrowlen=0;

int rowcount;

U32 lastlistid =0;
int listvalue[9];
int currentfontsize;
int newline=1;
int inacolor;

U8 chps=0;

int padding=1;
int verpadding=0;
int ignoreheadings=0;
long int cp;
static U8 header;
int breakcount;

char *symbolurl=NULL;
char *wingdingurl=NULL;

U16 read_16ubit(FILE *);
U32 read_32ubit(FILE *);

U16 sread_16ubit(U8 *in);
U8 sgetc(U8 *in);

U16 dread_16ubit(FILE *in,U8 **list);
U8 dgetc(FILE *in,U8 **list);

RETSIGTYPE reaper(int);
RETSIGTYPE timeingout(int );
void signal_handle (int sig, SigHandler * handler);

void cleanupstreams(char *analyze,char *slashtmp);
olestream * divide_streams(char *filename,char **analyze,char **slashtmp);

int decode_word8(char *mainstreamname,olestream *olestreams,int core);
void get_table_info(FILE *tablefd,list_info *a_list_info,U32 fcSttbFnm,U32 lcbSttbFnm,U32 fcPlcfLst,U32 lcbPlcfLst,U32 fcPlfLfo,U32 lcbPlfLfo,style *sheet);

pap *get_pap(U32 pageindex,FILE *in,U32 charindex, U32 *nextfc,style *sheet,list_info *a_list_info);
chp *get_chp(U32 pageindex,FILE *in, U32 charindex, U32 *nextfc,style *sheet,U16 istd);

void decode_clx(U32 startpiece,U32 begincp,U32 endcp,FILE *in,FILE *main,U32 fcClx,U32 lcbClx,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int headfooterflag);
void decode_clx_header(U32 *rgfc,int nopieces,U32 startpiece,U32 begincp,U32 endcp,FILE *in,FILE *main,U32 fcClx,U32 lcbClx,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int headerfooterflag);
void decode_clx_footer(U32 *rgfc,int nopieces,U32 startpiece,U32 begincp,U32 endcp,FILE *in,FILE *main,U32 fcClx,U32 lcbClx,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int headerfooterflag);

void decode_simple(FILE *mainfd,FILE *tablefd,U32 fcClx,U32 fcMin,U32 fcMac,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int flag);
void decode_simple_footer(FILE *mainfd,FILE *tablefd,U32 fcClx,U32 fcMin,U32 fcMac,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int flag);
void decode_simple_header(FILE *mainfd,FILE *tablefd,U32 fcClx,U32 fcMin,U32 fcMac,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int flag);

int decode_letter(int letter,int flag,pap *apap, chp * achp,field_info *magic_fields,FILE *main,ffn *fontnamelist,list_info *a_list_info,textportions *portions);
void decode_reference(textportions *portions, FILE *main);

void decode_s_specials(pap *apap,chp *achp,list_info *a_list_info);
void decode_s_table(pap *apap,chp *achp,list_info *a_list_info);
void decode_e_specials(pap *apap,chp *achp,list_info *a_list_info);
void decode_e_table(pap *apap,chp *achp,list_info *a_list_info);

void decode_s_chp(chp *achp);
void decode_e_chp(chp *achp);

void chpsoff(void);
void chpson(void);

void decode_list_nfc(int *value,int no_type);
void decode_list_level(pap *apap,int inalist);

void flushbreaks(void);

void decode_s_anld(pap *apap,chp *achp,list_info *a_list_info,ffn *fontnamelist);
void decode_s_list(pap *apap,chp *achp,list_info *a_list_info,ffn *fontnamelist);
void decode_e_list(pap *apap,chp *achp,list_info *a_list_info);

void decode_field(FILE *main,field_info *magic_fields,long *cp,U8 *fieldwas,long *swallowcp1,long *swallowcp2);

int find_FKPno_papx(U32 fc,U32 *plcfbtePapx,U32 intervals);
int find_FKPno_chpx(U32 fc,U32 *plcfbteChpx,U32 intervals);
U32 find_next_smallest_fc(U32 charindex,U32 pageindex, FILE *in, U8 *location,long *pos);

pap * get_complex_pap(U32 fc,U32 *plcfbtePapx,U8 i,U8 nopieces,U32 intervals,U32 *rgfc,FILE *main,U32 *avalrgfc,U32 *thenextone,U32 *theotherone,int *paraendpiece,style *sheet,list_info *a_list_info);
chp * get_complex_chp(U32 fc,U32 *plcfbteChpx,U8 i,U8 nopieces,U32 chpintervals,U32 *rgfc,FILE *main,U32 *avalrgfc,U32 *thenextone,style *sheet,U16 istd);

void decode_gpprls(pap *apap,chp *achp,U16* gpprlindex,int index,Sprm *sprmlists, style *sheet);

style *decode_stylesheet(FILE *tablefd,U32 stsh,U32 stshlen);
void fill_pap(style *stylelist,int m,int b);

void decode_sprm(FILE* in,U16 clist,pap *retpap,chp *retchp,U16 *pos,U8 **list, style *sheet,U16 istd);

void error(FILE *stream,char *fmt, ...);
void oprintf(int silentflag,char *fmt, ...);

int decode_symbol(U16 fontspec);
char *symbolfontdir(void);

int decode_wingding(U16 fontspec);
char *wingdingfontdir(void);

void decode_header(U32 *begin,U32 *len,textportions *portions);
void decode_header2(U32 *begin,U32 *len,textportions *portions);
void decode_footer(U32 *begin,U32 *len,textportions *portions);
void decode_footnote(U32 *begin,U32 *len,textportions *portions,int i);

int get_piecetable(FILE *in,U32 **rgfc,U32 **avalrgfc,U16 **sprm,U32 *clxcount);

void decode_ilfo(pap *retpap,list_info *a_list_info);

void init_chp(chp * achp);

char *ms_strlower(char *in);

void usage( void )
    {
    fprintf(stderr,"Usage: mswordview [-v] [--version] [-n] [--nocredits] [-c] [--corehtmlonly]  \n"
                "[-t seconds] [--timeout seconds] [-f points] [--defaultfontsize points] [-s url] [--symbolurl url] [-d url] \n"
				"[--wingdingurl url] [-h] [--ignoreheadings] filename.doc\n");
    exit(-1);
    }



int main(int argc,char **argv)
	{
	olestream *anolestream;
	olestream *oleptr;
	olestream *oleptr2;
	char *analyze;
	char *slashtmp;
	char *mainstreamname=NULL;
	int ret=0;
	int timeout=-1;
	char *filename;
	char *endptr;

	int c;
	int tail=1;
	int core=1;
	int index=0;

	chp achp;

	static struct option long_options[] = 
		{
		{ "version",0 , 0, 'v' },
		{ "corehtmlonly",0 , 0, 'c' },
		{ "nocredits",0 , 0, 'n' },
		{ "timeout",1 , 0, 't' },
		{ "nohorizontalwhite",0,0,'w'},
		{ "verticalwhite",1,0,'u'},
		{ "symbolurl", 1,0,'s'},
		{ "wingdingurl", 1,0,'d'},
		{ "ignoreheadings", 0,0,'h'},
		{ "defaultfontsize", 1,0,'f'},
		{ 0,      0, 0, '0' },
		};


	while (1)
		{
		c = getopt_long (argc, argv, "vwncaht:s:d:f:u:", long_options, &index);
		if (c == -1)
			break;
		switch(c)
			{
			case 'f':
				if (optarg)
					{
                   	NORMAL = strtol(optarg, &endptr, 10);
				   	if ((*optarg == '\0') || (*endptr  != '\0'))
						{
						fprintf(stderr,"f option must be followed with a number\n");
						NORMAL=20;
						}
					else
						NORMAL*=2;
				 	}
				else 
					{
					printf("no val given for defaultfontsize (-f) \n");
					NORMAL=20;
					}
				break;
			case 'v':
				printf ("%s\nwriten by Caolan.McNamara@ul.ie\nweb page for updates at \nhttp://www.gnu.org/~caolan/docs/MSWordView.html   or\nhttp://www.csn.ul.ie/~caolan/docs/MSWordView.html\n", version);
				exit (0);
				break;
			case 'h':
				ignoreheadings=1;
				break;
			case 'n':
				tail=0;
				break;	
			case 'u':
				if (optarg)
					{
                   	verpadding = strtol(optarg, &endptr, 10);
				   	if ((*optarg == '\0') || (*endptr  != '\0'))
						{
						fprintf(stderr,"u option must be followed with a number\n");
						verpadding=0;
						}
					if ((verpadding < 0) || (verpadding > 2))
						{
						fprintf(stderr,"u option accepts on 0,1,2 as an argument, not %d\n",verpadding);
						verpadding=0;
						}
				 	}
				else 
					{
					printf("no val given for verticalpadding (-u) \n");
					verpadding=0;
					}
				break;
				
				break;	
			case 't':
				if (optarg)
					{
                   	timeout = strtol(optarg, &endptr, 10);
				   	if ((*optarg == '\0') || (*endptr  != '\0'))
						fprintf(stderr,"t option must be followed with a number\n");
				 	}
				else 
					printf("no val given for timeout option (-t)\n");
				break;
			case 's':
				if (optarg)
					{
					symbolurl = malloc(strlen(optarg)+1);
					if (symbolurl == NULL)
						{
						fprintf(stderr,"no mem\n");
						exit(-1);
						}
					strcpy(symbolurl,optarg);
					}
                else
                    printf("no val given\n");
                break;
			case 'd':
				if (optarg)
					{
					wingdingurl = malloc(strlen(optarg)+1);
					if (wingdingurl == NULL)
						{
						fprintf(stderr,"no mem\n");
						exit(-1);
						}
					strcpy(wingdingurl,optarg);
					}
                else
                    printf("no val given\n");
                break;
			case 'w':
				padding=0;
				break;
			case 'c':
				core=0;
				break;
			default:
				usage();
				break;
			}
		}

	if (argc <= optind) 
		{
		usage();
		}

	if (optind < argc)
		filename = strdup(argv[optind]);
	else 
		filename =NULL;

	/*set SIGCHLD handled*/
	signal_handle (SIGCHLD, reaper);

	currentfontsize = NORMAL;

	if (timeout != -1)
		{
		signal_handle (SIGALRM, timeingout);
		/*well abort after this number of seconds*/
		alarm(timeout);
		}

	/*
	use laola package to get ole stream information and to create 
	individual files for these streams
	*/
	anolestream = divide_streams(filename,&analyze,&slashtmp);
	/*now we have a list of the streamnames and the filenames needed*/

	/*search for main stream*/
	oleptr = anolestream;
	while (oleptr != NULL)
		{
		if (oleptr->level == 0)
			if (strncmp("WordDocument",oleptr->streamname,strlen("WordDocument")) == 0)
				{
				mainstreamname = oleptr->filename;
				break;
				}
		oleptr = oleptr->next;
		}

	if (mainstreamname == NULL)
		{
		printf("Sorry main document stream couldnt be found in doc \n%s\n",filename);
		printf("if this *is* a word 8 file, it appears to be corrupt\n");
		printf("or for some other reason laola cant split it into its streams\n");
		printf("this is probably a laola problem - not a mswordview problem\n");
		}
	else
		ret = decode_word8(mainstreamname,anolestream,core);

	/*remove stream files*/
	cleanupstreams(analyze,slashtmp);

	/*free mem*/
	oleptr = anolestream->next;

	while(oleptr != NULL)
		{
		oleptr2 = oleptr;
		oleptr = oleptr->next;
		free(oleptr2);
		}
	free(anolestream);
	if (ret != -1)
		{
		if (tail)
			{
			init_chp(&achp);
			decode_s_chp(&achp);
			printf("<p>\nDocument converted from word 8 by \n<a href=\"http://www.csn.ul.ie/~caolan/docs/MSWordView.html\">MSWordView</a> (%s)<br>\n",version);
			printf("MSWordView written by <a href=\"mailto:Caolan.McNamara@ul.ie\">Caolan McNamara</a>\n</body>\n");
			}
		if (core)
			printf("\n</html>\n");
		}
	return(ret);
	}


olestream * divide_streams(char *filename,char **analyze,char **slashtmp)
	{
	olestream *olelist;
	olestream *olelistptr;
	pid_t pid;
    int filedes[2];
    char *execut[4];
    char buffer[4096];
    char fullfilepath[PATH_MAX];
    char currentdir[PATH_MAX];
    int i,j,k=0;
    int scan=0;
    int scanbracket=0;
	int scanlevel=0;
	int level=0;
	
	char numbers[4];
	
	char *ptr=NULL;
    char basename[PATH_MAX];

	memset(fullfilepath, 0, PATH_MAX);
	memset(currentdir, 0, PATH_MAX);
	memset(basename, 0, PATH_MAX);

    execut[0] = "lls-mswordview";
    execut[1] = "-s";
    execut[3] = NULL;


	if (pipe (filedes))
        {
        fprintf (stderr, "Pipe failed.\n");
        exit(-1);
        }

    if (filename[0] != '/')
        {
        if (NULL == getcwd(currentdir,PATH_MAX))
            {
            fprintf (stderr, "couldnt get current directory\n");
            exit(-1);
            }
        strcpy(fullfilepath,currentdir);
        }
    if (fullfilepath[strlen(fullfilepath)] != '/')
        strcat(fullfilepath,"/");
    strncat(fullfilepath,filename,PATH_MAX-(strlen(fullfilepath)+1));
    error(stderr,"full filename is %s\n",fullfilepath);

    execut[2] = fullfilepath;

    *slashtmp = tmpnam(NULL);
    if (0 != mkdir((const char *)*slashtmp,S_IRWXU))
        {
        fprintf (stderr, "mkdir of %s failed\n",*slashtmp);
        exit(-1);
        }
    else
        {
        error(stderr, "mkdir of %s suceeded\n",*slashtmp);
        }

	*analyze =(char *) malloc (strlen(*slashtmp) + strlen("analyze") + 3);
    if (*analyze == NULL)
        {
        fprintf (stderr, "malloc failed\n");
        exit (-1);
        }
    strcpy(*analyze,*slashtmp);
    strcat(*analyze,"/analyze/");

	strcpy(basename,*analyze); 

	pid = fork ();
    if (pid == (pid_t) 0)  /*child*/
        {
        close (1);                      /* close stdout */
        dup (filedes[1]);               /* make pipe stdout */
        close (filedes[1]);
        chdir(*slashtmp);
        execvp(execut[0],(char* const *) execut);
#if defined(HAVE_ERRNO_H)
		fprintf( stderr, "Exec of %s failed with error code %d\n", execut[0], errno );
#else
		fprintf( stderr, "Exec of %s failed\n", execut[0]);
#endif
		exit(-1);
        }
    else if (pid < (pid_t) 0)
        {
        /* The fork failed. */
        fprintf (stderr, "Fork failed.\n");
        exit (-1);
        }

    close (filedes[1]);


	olelist = (olestream *) malloc(sizeof(olestream));
	if (olelist == NULL)
		{
		fprintf (stderr, "malloc failed.\n");
        exit (-1);
		}


	/*work backwards to the the first / or beginning*/

	k = strlen(basename);

	j=strlen(filename);
    while((filename[j] != '/') && (j!=0))
		j--;

	/*j now a beginning of basename*/
    while((filename[j] != '.') && (j<strlen(filename)))
		{
        basename[k++] = filename[j++];
		basename[k] = '\0';
		}

	basename[k++] = '.';
	basename[k] = '\0';
	error(stderr,"basename is %s\n",basename);

	/*ta-da*/
    /*basename[k] = '0';*/

    error(stderr,"filename base is %s\n",basename);

    olelistptr = olelist;


	while (read (filedes[0],buffer,4096) > 0)
        {
        for (i=0;i<strlen(buffer);i++)
            {
            if ((buffer[i] == '\'') && (scan == 0))
                {
                scan=1;
                ptr = olelistptr->streamname;
                j=0;
                }
            else if ((buffer[i] == '\'') && (scan == 1))
                {
                scan=0;
                ptr[j] = '\0';
                }
            else if ((buffer[i] == '(') && (scanbracket == 0))
                {
				error(stderr,"streamname is %s\n",olelistptr->streamname);
                scanbracket=1;
				ptr = numbers;
				j = 0;
				/*
                strcpy(olelistptr->filename,basename);
                ptr = olelistptr->filename;
                j=strlen(olelistptr->filename);
				*/
                }
            else if ((buffer[i] == ')') && (scanbracket == 1))
                {
                scanbracket=0;
                ptr[j] = '\0';
				error(stderr,"filename nos %s\n",numbers);
				sprintf(olelistptr->filename,"%s%0.2x",basename,strtol(numbers,(char **)NULL,16));
				error(stderr,"filename is %s\n",olelistptr->filename);
				olelistptr->level = level/3;
				error(stderr,"level is %d\n",level/3);
                olelistptr->next = (olestream *) malloc(sizeof(olestream));
                if (olelistptr == NULL)
                    {
                    fprintf (stderr, "malloc failed.\n");
                    exit (-1);
                    }
                olelistptr = olelistptr->next;
                olelistptr->next=NULL;
                }
            else if (scan == 1)
                {
                ptr[j++] = buffer[i];
                }
            else if (scanbracket==1)
                {
                if (isxdigit(buffer[i]))
                    ptr[j++] = buffer[i];
                }
			else if (buffer[i] == ':')
				{
				scanlevel=1;
				level=0;
				}
			else if (scanlevel == 1)
				{
				if (isspace(buffer[i]))
					level++;
				else
					scanlevel=0;
				}
            }
        }

	return(olelist);
	}

void cleanupstreams(char *analyze,char *slashtmp)
	{
	DIR *adir;
	struct dirent *thedir;
    	char currentdir[PATH_MAX] ="/";


 	if (NULL == getcwd(currentdir,PATH_MAX))
            {
            fprintf (stderr, "couldnt get current directory,continuing\n");
            }

	chdir(analyze);
	adir = opendir(analyze);	
	if (adir == NULL)
		{
		error (stderr, "couldnt open %s\n",analyze);
		}
	else
		{
		while (NULL != (thedir = readdir(adir)))
			{
			if (strcmp(thedir->d_name,"..") && strcmp(thedir->d_name,"."))
				{
				error(stderr,"removing %s\n",thedir->d_name);
				remove(thedir->d_name);
				}
			}

		closedir(adir);
		}

	chdir(currentdir);

	if (0 != rmdir((const char *)analyze))
		{
		error (stderr, "rmdir of %s failed\n",analyze);
		}
	else
		{
		error(stderr, "rmdir of %s suceeded\n",analyze);
		}

	if (0 != rmdir((const char *)slashtmp))
		{
		fprintf (stderr, "rmdir of %s failed\n",slashtmp);
		}
	else
		{
		error (stderr, "rmdir of %s suceeded\n",slashtmp);
		}
	}


int decode_word8(char *mainstreamname,olestream *olestreams,int core)
	{
	U32 i,j,k;
	
	U16 wIdent,nFib,nProduct,lid,pnNext,nFibBack,chse,chseTables;
	U32 lKey,fcMin,fcMac,cbMac,fcSpare,ccpMcr,ccpAtn,ccpEdn,ccpTxbx,ccpHdrTxbx,ccpSpare2,fcStshfOrig,lcbStshfOrig;
	textportions portions;
	U8 fields1,fields2,envr,reserved;
	U8 iscomplex=0;
	U32 pnPapFirst,cpnBtePap;
	U32 pnChpFirst,cpnBteChp;
	U32 pnLvcFirst,cpnBteLvc;
	U32 fcPlcfbtePapx,lcbPlcfbtePapx;
	U32 fcPlcfbteChpx,lcbPlcfbteChpx;
	U32 *plcfbtePapx;
	U32 *plcfbteChpx;
	U32 chpintervals;
	U32 intervals;
	U32 fcClx,lcbClx;
	U32 fcPlcffldMom,lcbPlcffldMom;
	U32 fcPlcffldHdr,lcbPlcffldHdr;
	U32 fcPlcffldFtn,lcbPlcffldFtn;
	U32 fcSttbfffn,lcbSttbfffn;
	ffn fontnamelist;
	ffn *tempnames;
	U32 *cp_plcfld;
	U8 *fld_plcfld;
	U32 *cp_plcfld2;
	U8 *fld_plcfld2;
	U32 *cp_plcfld3;
	U8 *fld_plcfld3;
	U8 len;
	char *tablename;
	char *tablestreamname=NULL;
	olestream *oleptr;
	field_info *all_fields[3];
	field_info main_fields;
	field_info header_fields;
	field_info footnote_fields;
	U32 fcPlcfLst,lcbPlcfLst;
	U32 fcPlfLfo,lcbPlfLfo;
	U32 fcSttbFnm,lcbSttbFnm;
	U32 fcPlcffndRef;
	U32 fcPlcffndTxt;
	U32 lcbPlcffndRef;
	U32 lcbPlcffndTxt;

	U32 stsh,stshlen;
	
	list_info a_list_info;
	style *masterstylesheet;

	FILE *tablefd;
	FILE *mainfd;

	int notfinished;

	error(stderr,"opening %s\n",mainstreamname);
	mainfd = fopen(mainstreamname,"r");
	if (mainfd == NULL)
		{
		fprintf(stderr,"Couldnt open %s\n",mainstreamname);
		exit(-1);
		}
	
	wIdent=read_16ubit(mainfd);
	nFib=read_16ubit(mainfd);
	nProduct=read_16ubit(mainfd);


	if (nFib >= 101)
		error(stderr,"written by word >= 6, exactly %x\n",nProduct);
	else
		error(stderr,"written by word < 6, exactly %x\n",nProduct);

	if ((nProduct >> 8) == 0xe0)
		{
		printf("this is an unsupported word 7 doc, sorry\nthis converter is solely for word8 at the moment\ntry laola (http://wwwwbs.cs.tu-berlin.de/~schwartz/pmh/laola.html) it might get some text out of it\n");
		return(-1);
		}
	else if ((nProduct >> 8) == 0xc0)
		{
		printf("this is an unsupported (as of yet) word 6 doc, sorry\nthis converter is solely for word8 at the moment\ntry word2x (http://word2x.astra.co.uk/) for that\n");
		return(-1);
		}
	else if ((nProduct >> 8) != 0x00)
		printf("this doesnt appear to be a word 8 doc, but going ahead anyway, expect disaster!!\n");

	lid=read_16ubit(mainfd);
	pnNext=read_16ubit(mainfd);
	fields1 = getc(mainfd);
	error(stderr,"wIdent is %d,nFib is %d, nProduct is %d, lid is %d, pnNext? is %d\n",wIdent,nFib,nProduct,lid,pnNext);
		
	if (fields1 & 0x01)
		error(stderr,"mainfdot\n");
	if (fields1 & 0x02)
		error(stderr,"fGlsy\n");
	if (fields1 & 0x04)
		{
		error(stderr,"fComplex\n");
		iscomplex=1;
		error(stderr,"complex doc, here we go!\n");
		}
	if (fields1 & 0x08)
		error(stderr,"fHasPic\n");
	fields1 &= 0xF0;
	fields1 = fields1 >> 4;
	error(stderr,"no od saves is %d\n",fields1);
	fields2 = getc(mainfd);
	if (fields2 & 0x01)
		error(stderr,"fEncrypted\n");

	if (fields2 & 0x02)
		{
		tablename = "1Table";
		error(stderr,"use 1Table stream\n");
		}
	else
		{
		tablename = "0Table";
		error(stderr,"use 0Table stream\n");
		}

	oleptr = olestreams;
    while (oleptr != NULL)
        {
		if (oleptr->level == 0)
			if (strncmp(tablename,oleptr->streamname,strlen(tablename)) == 0)
				{
				tablestreamname = oleptr->filename;
				break;
				}
		oleptr = oleptr->next;
        }

    if (tablestreamname == NULL)
        fprintf(stderr,"Sorry table stream couldnt be found in doc\n");

	tablefd = fopen(tablestreamname,"r");
	if (tablefd == NULL)
		{
		fprintf(stderr,"arse couldnt open -%s-\n",tablestreamname);
		exit(-1);
		}

	if (fields2 & 0x04)
		error(stderr,"fReadOnlyRecommedned\n");
	if (fields2 & 0x08)
		error(stderr,"fWriteReservation\n");
	if (fields2 & 0x10)
		error(stderr,"fEctChar\n");
	nFibBack = read_16ubit(mainfd);
	lKey = read_32ubit(mainfd);
	envr = getc(mainfd);
	error(stderr,"nFibback is %d, lKey is %ld\n",nFibBack,lKey);
	if (envr == 0)
		error(stderr,"created in winword\n");
	else if (envr == 1)
		error(stderr,"created in mac word\n");
	reserved = getc(mainfd);
	chse = read_16ubit(mainfd);
	if (chse == 0)
		error(stderr,"windows ansi\n");
	else if (chse == 256)
		error(stderr,"mac char set\n");
	chseTables = read_16ubit(mainfd);
	if (chseTables == 0)
		error(stderr,"windows ansi\n");
	else if (chseTables== 256)
		error(stderr,"mac char set\n");

	fcMin = read_32ubit(mainfd);
	fcMac = read_32ubit(mainfd);
	fseek(mainfd,0x0040,SEEK_SET);
	cbMac = read_32ubit(mainfd);
	fcSpare= read_32ubit(mainfd);
	fcSpare= read_32ubit(mainfd);


	error(stderr,"first char is at %ld (%x)\n",fcMin,fcMin);
	error(stderr,"last char is at %ld (%x)\n",fcMac,fcMac);

	portions.ccpText = read_32ubit(mainfd);
	error(stderr,"the main doc text is of size %ld\n",portions.ccpText);
	portions.ccpFtn = read_32ubit(mainfd);
	error(stderr,"the footer text is of size %ld\n",portions.ccpFtn);
	portions.ccpHdd = read_32ubit(mainfd);
	error(stderr,"the header text is of size %ld\n",portions.ccpHdd);
	portions.fcMin = fcMin;
	portions.fcMac = fcMac;
	ccpMcr = read_32ubit(mainfd);
	ccpAtn = read_32ubit(mainfd);
	ccpEdn = read_32ubit(mainfd);
	ccpTxbx = read_32ubit(mainfd);
	ccpHdrTxbx = read_32ubit(mainfd);
	ccpSpare2 = read_32ubit(mainfd);
	fcStshfOrig = read_32ubit(mainfd);
	lcbStshfOrig = read_32ubit(mainfd);
	
	/*attempt to list all paragraph bounds*/

	fseek(mainfd,112,SEEK_SET);	
	pnChpFirst = read_32ubit(mainfd);
	cpnBteChp = read_32ubit(mainfd);
	error(stderr,"\n page of first different char type %d\nnumber of different character types %d\n",pnChpFirst,cpnBteChp);


	fseek(mainfd,124,SEEK_SET);	
	pnPapFirst = read_32ubit(mainfd);
	cpnBtePap = read_32ubit(mainfd);
	error(stderr,"\n page of first different para type %d\nnumber of different para types %d\n",pnPapFirst,cpnBtePap);
	
	fseek(mainfd,136,SEEK_SET);	
	pnLvcFirst = read_32ubit(mainfd);
	cpnBteLvc = read_32ubit(mainfd);
	error(stderr,"\n page of first different lvc type %d\nnumber of different lvc types %d\n",pnLvcFirst,cpnBteLvc);
	
	fseek(mainfd,154,SEEK_SET);	
	error(stderr,"the orig stsh is (%x), len (%x)\n",read_32ubit(mainfd),read_32ubit(mainfd));
	
	stsh = read_32ubit(mainfd);
	stshlen = read_32ubit(mainfd);
	error(stderr,"the new stsh is (%x), len (%x)\n",stsh,stshlen);

	masterstylesheet = decode_stylesheet(tablefd,stsh,stshlen);

	fcPlcffndRef=read_32ubit(mainfd);
	lcbPlcffndRef=read_32ubit(mainfd);
	fcPlcffndTxt=read_32ubit(mainfd);
	lcbPlcffndTxt=read_32ubit(mainfd);

	error(stderr,"footnote: table offset of frd thingies (%x) of len %d\n",fcPlcffndRef,lcbPlcffndRef);
	error(stderr,"there are %d footnotes\n",(lcbPlcffndRef-4)/6);

	error(stderr,"footnote: table offset for footnote text (%x) of len %d\n",fcPlcffndTxt,lcbPlcffndTxt);

	portions.fndRef=NULL;
	portions.fndFRD=NULL;
	portions.fndTxt=NULL;
	portions.list_foot_no = 0;

	portions.fndref_no=0;
	portions.fndtxt_no=0;

	if (lcbPlcffndRef != 0)
		{
		portions.fndref_no=(lcbPlcffndRef-4)/6;
		portions.fndRef = (U32 *) malloc( (portions.fndref_no+1) * sizeof(U32));
		if (portions.fndRef == NULL)
			{
			fprintf(stderr,"NO MEM 1\n");
			return(-1);
			}

		portions.fndFRD = (U16 *) malloc( portions.fndref_no * sizeof(U16));
		if (portions.fndFRD == NULL)
			{
			fprintf(stderr,"NO MEM 2\n");
			return(-1);
			}
		fseek(tablefd,fcPlcffndRef,SEEK_SET);
		for(i=0;i<portions.fndref_no+1;i++)
			portions.fndRef[i]=read_32ubit(tablefd);
		for(i=0;i<portions.fndref_no;i++)
			portions.fndFRD[i]=read_16ubit(tablefd);
		}

	if (lcbPlcffndTxt!= 0)
		{
		fseek(tablefd,fcPlcffndTxt,SEEK_SET);
		portions.fndtxt_no=lcbPlcffndTxt/4;
		portions.fndTxt = (U32 *) malloc( portions.fndtxt_no  * sizeof(U32) );
		if (portions.fndTxt == NULL)
			{
			fprintf(stderr,"NO MEM 3\n");
			return(-1);
			}
		fseek(tablefd,fcPlcffndTxt,SEEK_SET);
		for (i=0;i<portions.fndtxt_no;i++)
			portions.fndTxt[i]=read_32ubit(tablefd);
		}
	
	
	fseek(mainfd,242,SEEK_SET);	
	portions.fcPlcfhdd = read_32ubit(mainfd);
	portions.lcbPlcfhdd = read_32ubit(mainfd);
	/*these point to the header/footer information thing*/

	error(stderr,"header in table offset of (%x), len is %d\n",portions.fcPlcfhdd,portions.lcbPlcfhdd);
	
	fcPlcfbteChpx = read_32ubit(mainfd);
	lcbPlcfbteChpx = read_32ubit(mainfd);
	error(stderr,"\nlocation of char description in table stream is %x\nsize is %ld\n",fcPlcfbteChpx,lcbPlcfbteChpx);
	plcfbteChpx = (U32 *) malloc(lcbPlcfbteChpx);
	fseek(tablefd,fcPlcfbteChpx,SEEK_SET);
	for (i=0;i<lcbPlcfbteChpx/4;i++)
		plcfbteChpx[i] = read_32ubit(tablefd);
	chpintervals = ((lcbPlcfbteChpx/4)-1)/2;
	error(stderr,"there are %d charrun intervals ? ending at ",chpintervals);
	for (i=1;i<chpintervals+1;i++)
		error(stderr,"%d (%d)", plcfbteChpx[i],plcfbteChpx[i+chpintervals]);
	error(stderr,"\n");


	fcPlcfbtePapx = read_32ubit(mainfd);
	lcbPlcfbtePapx = read_32ubit(mainfd);
	error(stderr,"\nlocation of para description in table stream is %ld\nsize is %ld\n",fcPlcfbtePapx,lcbPlcfbtePapx);
	/*go to location in table stream, */
	/*i believe that this is just an array of longs(4 bytes blocks)
	 */
	plcfbtePapx = (U32 *) malloc(lcbPlcfbtePapx);
	fseek(tablefd,fcPlcfbtePapx,SEEK_SET);
	for (i=0;i<lcbPlcfbtePapx/4;i++)
		plcfbtePapx[i] = read_32ubit(tablefd);
	intervals = ((lcbPlcfbtePapx/4)-1)/2;
	error(stderr,"there are %d pragraph intervals ? ending at ",intervals);
	for (i=1;i<intervals+1;i++)
		error(stderr,"%d %x (%d)", plcfbtePapx[i], plcfbtePapx[i],plcfbtePapx[i+intervals]);
	error(stderr,"\n");
	fseek(mainfd,274,SEEK_SET);
	fcSttbfffn=read_32ubit(mainfd);
	lcbSttbfffn=read_32ubit(mainfd);

	if (lcbSttbfffn > 0)
		{
		tempnames = &fontnamelist;
		error(stderr,"have a table of font names (%x)\n",fcSttbfffn);
		fseek(tablefd,fcSttbfffn,SEEK_SET);

		j=0;
		/*seems to be a count of font names, followed by three blanks ?*/
		read_16ubit(tablefd);
		read_16ubit(tablefd);
		j=4;
		while(j<lcbSttbfffn)
			{
			k=0;
			tempnames->name[0] = '\0';
			tempnames->next=NULL;
			len = getc(tablefd);
			error(stderr,"len is %d\n",len);
			i=1;
			notfinished=1;
			while(i<=len)
				{
				if ((i >= 40) && (notfinished))
					{
					tempnames->name[k] = read_16ubit(tablefd);
					i+=2;
					error(stderr,"font name char is %X %c %x i is %d\n",tempnames->name[k],tempnames->name[k],ftell(tablefd),i);
					if (tempnames->name[k] == 0)
						notfinished=0;
					k++;
					}
				else
					{	
					if (i==4)
						{
						tempnames->chs = getc(tablefd);
						error(stderr,"chs is (%x)  %d ",tempnames->chs,tempnames->chs);
						}
					else
						getc(tablefd);
					i++;
					}
				}
			if (tempnames->name[0] != '\0')
				{
				tempnames->next = (ffn *) malloc(sizeof(ffn));
				if (tempnames->next == NULL)
					{
					fprintf(stderr,"no memory, arrgh\n");
					return(-1);
					}
				tempnames = tempnames->next;
				}
			j+=i;	
			}
		}

	tempnames = &fontnamelist;
	while (tempnames != NULL)
		{
		error(stderr,"font names are %s\n",tempnames->name);
		tempnames = tempnames->next;
		}

	/*determine field plc*/
	fcPlcffldMom=read_32ubit(mainfd);
	lcbPlcffldMom=read_32ubit(mainfd);
	error(stderr,"in table stream field plc is %ld, and len is %ld\n",fcPlcffldMom,lcbPlcffldMom);

	main_fields.cps = NULL;
	main_fields.flds = NULL;
	main_fields.no = -1;

	if (lcbPlcffldMom > 0)
		{
		error(stderr,"guessing that no of entries is %d\n",(lcbPlcffldMom-4)/6);
		cp_plcfld = (U32 *) malloc( (((lcbPlcffldMom-4)/6)+1) * sizeof(U32));
		if (cp_plcfld == NULL)
			{
			fprintf(stderr,"no mem\n");
			exit(-1);
			}

		fld_plcfld = (U8 *) malloc( (((lcbPlcffldMom-4)/6)*2) * sizeof(U8));
		if (fld_plcfld == NULL)
			{
			fprintf(stderr,"no mem\n");
			exit(-1);
			}

		fseek(tablefd,fcPlcffldMom,SEEK_SET);
		for(i=0;i<(((lcbPlcffldMom-4)/6)+1);i++)
			{
			cp_plcfld[i] =  read_32ubit(tablefd);
			error(stderr,"field cps are %x\n",cp_plcfld[i]);
			}
		for(i=0;i<(((lcbPlcffldMom-4)/6)*2);i++)
			{
			fld_plcfld[i] =  getc(tablefd);
			error(stderr,"field vals are %d\n",fld_plcfld[i]);
			}

		main_fields.cps = cp_plcfld;
		main_fields.flds = fld_plcfld;
		main_fields.no = (lcbPlcffldMom-4)/6;
		}

	fcPlcffldHdr=read_32ubit(mainfd);
	lcbPlcffldHdr=read_32ubit(mainfd);
	error(stderr,"in table stream field header plc is (%x), and len is %ld\n",fcPlcffldHdr,lcbPlcffldHdr);

	header_fields.cps = NULL;
	header_fields.flds = NULL;
	header_fields.no = -1;

	if (lcbPlcffldHdr> 0)
		{
		error(stderr,"guessing that no of entries is %d\n",(lcbPlcffldHdr-4)/6);
		cp_plcfld2 = (U32 *) malloc( (((lcbPlcffldHdr-4)/6)+1) * sizeof(U32));
		if (cp_plcfld2 == NULL)
			{
			fprintf(stderr,"no mem\n");
			exit(-1);
			}

		fld_plcfld2 = (U8 *) malloc( (((lcbPlcffldHdr-4)/6)*2) * sizeof(U8));
		if (fld_plcfld2 == NULL)
			{
			fprintf(stderr,"no mem\n");
			exit(-1);
			}

		fseek(tablefd,fcPlcffldHdr,SEEK_SET);
		for(i=0;i<(((lcbPlcffldHdr-4)/6)+1);i++)
			{
			cp_plcfld2[i] =  read_32ubit(tablefd);
			error(stderr,"header field cps are %x\n",cp_plcfld2[i]);
			}
		for(i=0;i<(((lcbPlcffldHdr-4)/6)*2);i++)
			{
			fld_plcfld2[i] =  getc(tablefd);
			error(stderr,"field vals are %d\n",fld_plcfld2[i]);
			}

		header_fields.cps = cp_plcfld2;
		header_fields.flds = fld_plcfld2;
		header_fields.no = (lcbPlcffldHdr-4)/6;
		}

	fcPlcffldFtn=read_32ubit(mainfd);
	lcbPlcffldFtn=read_32ubit(mainfd);
	error(stderr,"in table stream field footnote plc is (%x), and len is %ld\n",fcPlcffldFtn,lcbPlcffldFtn);

	footnote_fields.cps = NULL;
	footnote_fields.flds = NULL;
	footnote_fields.no = -1;

	if (lcbPlcffldFtn >0)
		{
		error(stderr,"guessing that no of entries is %d\n",(lcbPlcffldFtn-4)/6);
		cp_plcfld3 = (U32 *) malloc( (((lcbPlcffldFtn-4)/6)+1) * sizeof(U32));
		if (cp_plcfld3 == NULL)
			{
			fprintf(stderr,"no mem\n");
			exit(-1);
			}

		fld_plcfld3 = (U8 *) malloc( (((lcbPlcffldFtn-4)/6)*2) * sizeof(U8));
		if (fld_plcfld3 == NULL)
			{
			fprintf(stderr,"no mem\n");
			exit(-1);
			}

		fseek(tablefd,fcPlcffldFtn,SEEK_SET);
		for(i=0;i<(((lcbPlcffldFtn-4)/6)+1);i++)
			{
			cp_plcfld3[i] =  read_32ubit(tablefd);
			error(stderr,"footnote field cps are %x\n",cp_plcfld3[i]);
			}
		for(i=0;i<(((lcbPlcffldFtn-4)/6)*2);i++)
			{
			fld_plcfld3[i] =  getc(tablefd);
			error(stderr,"field vals are %d\n",fld_plcfld3[i]);
			}

		footnote_fields.cps = cp_plcfld3;
		footnote_fields.flds = fld_plcfld3;
		footnote_fields.no = (lcbPlcffldFtn-4)/6;
		}

	all_fields[0] = &main_fields;
	all_fields[1] = &header_fields;
	all_fields[2] = &footnote_fields;


	/*complex info bit*/
	fseek(mainfd,418,SEEK_SET);
	fcClx =  read_32ubit(mainfd);
	lcbClx = read_32ubit(mainfd);
	error(stderr,"complex bit begins at %X, and it %d long",fcClx,lcbClx);

	fseek(mainfd,730,SEEK_SET);
	fcSttbFnm =  read_32ubit(mainfd);
	lcbSttbFnm = read_32ubit(mainfd);
	fcPlcfLst =  read_32ubit(mainfd);
	lcbPlcfLst = read_32ubit(mainfd);
	fcPlfLfo =  read_32ubit(mainfd);
	lcbPlfLfo = read_32ubit(mainfd);

	get_table_info(tablefd,&a_list_info,fcSttbFnm,lcbSttbFnm,fcPlcfLst,lcbPlcfLst,fcPlfLfo,lcbPlfLfo,masterstylesheet);

	error(stderr,"\n-----text------ %x\n",1024);
	if (core)
		printf("<html>\n");
	fseek(mainfd,1024,SEEK_SET);

	error(stderr,"endpoint for standard is %ld\n",fcMac);


	fseek(tablefd,portions.fcPlcfhdd,SEEK_SET);
	portions.headercpno = portions.lcbPlcfhdd/4;
	portions.headercplist = NULL;
	if (portions.headercpno > 0)
		{
		error(stderr,"head no is %d\n",portions.headercpno);
		portions.headercplist = malloc(sizeof(U32) * portions.headercpno);
		if (portions.headercplist == NULL)
			{
			error(stderr,"feck no mem\n");
			return(-1);
			}

		for (i=0;i<portions.headercpno;i++)
			{
			portions.headercplist[i]= read_32ubit(tablefd);
			error(stderr,"header fc ? is %x -> %x\n",portions.headercplist[i],portions.fcMin+portions.ccpText+portions.ccpFtn+portions.headercplist[i]);
			}
		}

	if (iscomplex)
		{
		error(stderr,"complex writing complex table looking in %ld (len %ld)\n",fcClx,lcbClx);
		/*i believe that the intervals and plcfbtePapx are valid entities for
		fastsaved docs as well (i bloody hope so)*/
		printf("<!--complex document-->\n");
		error(stderr,"main ends at %x\n",portions.ccpText);
		decode_clx(0,0,portions.ccpText,tablefd,mainfd,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,&a_list_info,masterstylesheet,&portions,&fontnamelist,0);
		}
	else
		{
		error(stderr,"decoding simple\n");
		printf("<!--noncomplex document-->\n");

		
		decode_simple(mainfd,tablefd,fcClx,fcMin,fcMac,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,&a_list_info,masterstylesheet,&portions,&fontnamelist,0);
		}

	free(plcfbtePapx);
	return(0);
	}



void get_table_info(FILE *tablefd,list_info *a_list_info,U32 fcSttbFnm,U32 lcbSttbFnm,U32 fcPlcfLst,U32 lcbPlcfLst,U32 fcPlfLfo,U32 lcbPlfLfo, style *sheet)
	{
	U32 i,j;
	int k;
	U16 t;
	U8 len,chplen,paplen;
	pap listpap;

	int startno;
	int starttype;

	U16 temp16;

	U16 baseistd=1;

	U16 level=0;

	U16 *list_string=NULL;

	list_def *tempdef;
	list_def *tempdef2;
	list_def *defptr=NULL;

	chp achp;

	a_list_info->array = NULL;
	a_list_info->count= 0;
	a_list_info->lstarray = NULL;
	a_list_info->lstcount= 0;


	error(stderr,"table names begins at %X, and it %d long",fcSttbFnm,lcbSttbFnm);
	if (lcbSttbFnm !=0)
		{
		fseek(tablefd,fcSttbFnm,SEEK_SET);

		for(i=0;i<lcbSttbFnm;i++)
			{
			error(stderr,"%x ",getc(tablefd));
			}
		error(stderr,"\n"); 
		}

	if (lcbPlcfLst!=0)
		{
		error(stderr,"table lst begins at %X, and it %d long",fcPlcfLst,lcbPlcfLst);
		fseek(tablefd,fcPlcfLst,SEEK_SET);

		a_list_info->lstarray = (U8 *) malloc(lcbPlcfLst);
		if (a_list_info->lstarray == NULL)
			{
			fprintf(stderr,"no memory, lp\n");
			exit(-1);
			}
		a_list_info->lstcount = lcbPlcfLst;
		
		a_list_info->nooflsts = read_16ubit(tablefd);
		error(stderr,"number of lsts is %d\n",a_list_info->nooflsts);

		a_list_info->o_lst_ids = (U32 *) malloc(sizeof(U32) * a_list_info->nooflsts);
		if (a_list_info->o_lst_ids== NULL)
			{
			fprintf(stderr,"no memory here\n");
			exit(-1);
			}

		a_list_info->level = (U8 *) malloc(a_list_info->nooflsts);
		if (a_list_info->level == NULL)
			{
			fprintf(stderr,"no memory here\n");
			exit(-1);
			}

		i=0;
		k=0;
		while ( (i<lcbPlcfLst-2) && (k <a_list_info->nooflsts) )
			{
			a_list_info->o_lst_ids[k] = read_32ubit(tablefd);
			error(stderr,"ID is %x\n",a_list_info->o_lst_ids[k]);
			error(stderr,"template ID is %x\n",read_32ubit(tablefd));
			i+=8;
			for(j=0;j<18;j++)
				{
				a_list_info->lstarray[j] = getc(tablefd);
				i++;
				error(stderr,"%x ",a_list_info->lstarray[j]);
				}
			a_list_info->level[k] = getc(tablefd);
			error(stderr,"level flag is %x\n",a_list_info->level[k]);
			a_list_info->level[k] &= 0x01;
			getc(tablefd);
			i+=2;
			k++;
			}
		error(stderr,"\n"); 
		a_list_info->a_list_def = (list_def *)malloc(a_list_info->nooflsts*sizeof(list_def));
		if (a_list_info->a_list_def == NULL)
			{
			fprintf(stderr,"no memory ppp\n");
			exit(-1);
			}
		

		error(stderr,"table lst begins at %X, ends at %x",fcPlcfLst,fcPlcfLst+lcbPlcfLst);
		error(stderr,"but table override begins at %X, and it %d long ends at %x",fcPlfLfo,lcbPlfLfo,fcPlfLfo+lcbPlfLfo);

		fseek(tablefd,fcPlcfLst+lcbPlcfLst,SEEK_SET);

		/*begin determined with a hex editor*/
		i=0;
		k=0;
		while ( (i<fcPlfLfo-(fcPlcfLst+lcbPlcfLst)) && (k < a_list_info->nooflsts) )
		/*
		while (i<fcPlfLfo-(fcPlcfLst+lcbPlcfLst)) 
		*/
			{

			error(stderr,"discarding unknown list related data list data");

			startno = getc(tablefd);
			i++;
			error(stderr,"start no is %d\n",startno);

			for(j=0;j<3;j++)
				{
				error(stderr,"unknown: %x\n",getc(tablefd));
				i++;
				}

			starttype = getc(tablefd);
			i++;
			error(stderr,"start type is %d\n",starttype);
			if (starttype == 0)
				error(stderr,"normal type\n");
			else if (starttype == 1)
				error(stderr,"roman type\n");
			else if (starttype == 3)
				error(stderr,"alpha type\n");

			for(j=0;j<19;j++)
				{
				error(stderr,"unknown: %x\n",getc(tablefd));
				i++;
				}
			
			temp16 = getc(tablefd);
			temp16+=getc(tablefd);
			i+=2;
			error(stderr,"len ? %d (%x)\n",temp16,temp16);
			/*
			fill_pap(style *stylelist,int m,int b)
			*/
			baseistd = read_16ubit(tablefd);
			error(stderr,"base istd ? (%x)\n",baseistd);
			i+=2;
			t=0;
			len = temp16;
			error(stderr,"begin LIST PAP/CHP\n");
		
			init_chp(&achp);

			while(t<len)
				{
				temp16 = read_16ubit(tablefd);
				t+=2;
				decode_sprm(tablefd,temp16,&listpap,&achp,&t,NULL,sheet,baseistd);
				}
			i+=t;
			temp16 = read_16ubit(tablefd);
			i+=2;
			error(stderr,"len of string is %d\n",temp16);

			if (i == a_list_info->nooflsts)
				{
				error(stderr,"oh oh !\n");
				/* abandon as something has gone wrong, hope for the best*/
				break;
				}
			list_string = (U16 *) malloc(sizeof(U16) * (temp16+1));

			if (list_string == NULL)
				{
				fprintf(stderr,"no memory len %d\n",temp16);
				exit(-1);
				}

			error(stderr,"were at %x\n",ftell(tablefd));

			/*check the values, if it falls between 0 and 9, then this is the level we're at*/

			for (j=0;j<temp16;j++)
				{
				list_string[j] = read_16ubit(tablefd);
				i+=2;
				}

				
			list_string[j]='\0';
			for (j=0;j<temp16;j++)
				error(stderr,"%c %x",list_string[j],list_string[j]);


			if (a_list_info->level[k] == 1)
				{
				a_list_info->a_list_def[k].len = temp16;
				a_list_info->a_list_def[k].begin_no = startno;
				a_list_info->a_list_def[k].no_type = starttype;
				a_list_info->a_list_def[k].achp = achp;
				a_list_info->a_list_def[k].list_string = list_string;
				list_string = NULL;
				error(stderr,"simple list (no %d)\n",k);
				for (j=0;j<temp16;j++)
					error(stderr,"%c ",a_list_info->a_list_def[k].list_string[j]);
				defptr=NULL;
				k++;
				level=0;
				}
			else  /*long list*/
				{
				error(stderr,"complex list (no %d) level %d\n",k,level);
				if (level == 0)
					{
					a_list_info->a_list_def[k].len = temp16;
					a_list_info->a_list_def[k].begin_no = startno;
					a_list_info->a_list_def[k].no_type = starttype;
					a_list_info->a_list_def[k].achp = achp;
					a_list_info->a_list_def[k].list_string = list_string;
					a_list_info->a_list_def[k].sub_def_list=NULL;
					list_string = NULL;
					for (j=0;j<temp16;j++)
						error(stderr,"%c ",a_list_info->a_list_def[k].list_string[j]);
					defptr=NULL;
					}
				else
					{
					tempdef = (list_def *)malloc(sizeof(list_def));
					if (tempdef == NULL)
						{
						fprintf(stderr,"no memory ppp\n");
						exit(-1);
						}
					tempdef->len = temp16;
					tempdef->begin_no = startno;
					tempdef->no_type = starttype;
					tempdef->achp = achp;
					tempdef->list_string = list_string;
					tempdef->sub_def_list=NULL;
					if (level == 1)
						{
						a_list_info->a_list_def[k].sub_def_list = tempdef;
						defptr = a_list_info->a_list_def[k].sub_def_list;
						}
					else
						{
						if (defptr != NULL)
							{
							defptr->sub_def_list = tempdef;
							defptr =  defptr->sub_def_list;
							}
						else
							{
							error(stderr,"defptr was NULL !!\n");
							}
						}
					tempdef = tempdef->sub_def_list;
					}
				level++;
				if (level == 9)
					{
					k++;
					level=0;
					}
				}

			error(stderr,"end LIST PAP/CHP\n");
			tempdef=NULL;
			}
		/*end determined with a hex editor*/
		}

	fseek(tablefd,fcPlfLfo,SEEK_SET);

	if (lcbPlfLfo !=0)
		{
		fseek(tablefd,fcPlfLfo,SEEK_SET);

		a_list_info->array = (U8 *) malloc(lcbPlfLfo);
		if (a_list_info->array == NULL)
			{
			fprintf(stderr,"no memory ppsd\n");
			exit(-1);
			}
		a_list_info->count = lcbPlfLfo;

		a_list_info->nooflfos=read_32ubit(tablefd);
		error(stderr,"there are %ld LFO's\n",a_list_info->nooflfos);

		a_list_info->lst_ids = (U32 *) malloc(sizeof(U32) * a_list_info->nooflfos);
		if (a_list_info->lst_ids== NULL)
			{
			fprintf(stderr,"no memory opo\n");
			exit(-1);
			}

		a_list_info->overridecount = (int *) malloc(sizeof(int) * a_list_info->nooflfos);
		if (a_list_info->overridecount == NULL)
			{
			fprintf(stderr,"no memory opo\n");
			exit(-1);
			}

		a_list_info->o_list_def = (list_def *)malloc(a_list_info->nooflfos*sizeof(list_def));
		if (a_list_info->o_list_def == NULL)
			{
			fprintf(stderr,"scream\n");
			exit(-1);
			}

		for(i=0;i<a_list_info->nooflfos;i++)
			{
			a_list_info->lst_ids[i] = read_32ubit(tablefd);
			error(stderr,"IDHERE-->%x \n",a_list_info->lst_ids[i]);
			for (j=0;j<8;j++)
				error(stderr,"LFO:undoc %x\n",getc(tablefd));
			a_list_info->overridecount[i] = getc(tablefd);
			error(stderr,"is there a lfovl ? %d\n",a_list_info->overridecount[i]);

			k=0;
			while(k<a_list_info->nooflsts)
				{
				if (a_list_info->lst_ids[i]  == a_list_info->o_lst_ids[k])
					break;
				k++;
				}

			if (a_list_info->overridecount[i] > 0)
				{
				error(stderr,"create a copy\n");
				/*
				a_list_info->o_list_def[i] = (list_def *) malloc(sizeof(list_def));
				*/
				tempdef = &(a_list_info->o_list_def[i]);
				tempdef2 = &(a_list_info->a_list_def[k]);

				do
					{
					tempdef->len =  tempdef2->len;
					tempdef->begin_no = tempdef2->begin_no;
					tempdef->no_type =  tempdef2->no_type;
					tempdef->achp = tempdef2->achp;
					tempdef->list_string = (U16 *) malloc(sizeof(U16) * tempdef2->len+1);
					for (j=0;j<tempdef->len+1;j++)
						tempdef->list_string[j] = tempdef2->list_string[j];

					if (tempdef2->sub_def_list != NULL)
						tempdef->sub_def_list = (list_def *) malloc(sizeof(list_def));
					else
						tempdef->sub_def_list= NULL;
					tempdef = tempdef->sub_def_list;
					tempdef2 = tempdef2->sub_def_list;
					}
				while(tempdef2 != NULL);

				}
			else
				{
				a_list_info->o_list_def[i] = a_list_info->a_list_def[k];
				error(stderr,"linking lfo id %x %d to lst id %x %d\n",a_list_info->lst_ids[i],i,a_list_info->o_lst_ids,k);
				}
			for (j=0;j<3;j++)
				error(stderr,"LFO:undoc %x\n",getc(tablefd));
			}


		/*provisional code*/
		for(i=0;i<a_list_info->nooflfos;i++)
			{
			if (a_list_info->overridecount[i] > 0)
				{
				read_32ubit(tablefd); /*what the hell is this ????, dont know where it comes from*/
				error(stderr,"sitting at %x\n",ftell(tablefd));

				error(stderr,"startat etc ? is %x\n",read_32ubit(tablefd));
				len = getc(tablefd);
				tempdef2 = &(a_list_info->o_list_def[i]);
				error(stderr,"overrode level is %d\n",len & 0x0F);
				k = len & 0x0F;
				j=0;
				while(j < k)
					{
					if (tempdef2->sub_def_list != NULL)
						tempdef2 = tempdef2->sub_def_list;
					else
						error(stderr,"oh oh fell off end\n");
					j++;
					}

				error(stderr,"following LVL is %d\n",len & 0x20);
				len = len &= 0x01;
				for (j=0;j<3;j++)
					{
					error(stderr,"reserved %c\n",getc(tablefd));
					}
				error(stderr,"onto lvl\n");
				

				for (j=0;j<24;j++)
					{
					error(stderr,"temp unused %c\n",getc(tablefd));
					}
				paplen  = getc(tablefd);
				error(stderr,"pap len is %d\n",paplen);
				chplen = getc(tablefd);
				error(stderr,"chp len is %d\n",chplen);
				read_16ubit(tablefd);
				error(stderr,"sitting at %x\n",ftell(tablefd));


				error(stderr,"id is %x, adding to number %d\n",a_list_info->o_lst_ids[i],i);
				t=0;
				while(t<paplen+chplen)
					{
					temp16 = read_16ubit(tablefd);
					t+=2;
					/*ignore pap here*/
					decode_sprm(tablefd,temp16,&listpap,&(tempdef2->achp),&t,NULL,sheet,baseistd);
					}
				tempdef2->len = read_16ubit(tablefd);
				error(stderr,"following string is %d long\n",tempdef2->len);
				if (tempdef2->list_string != NULL)
					free(tempdef2->list_string);
				tempdef2->list_string = (U16*) malloc(sizeof(U16) * tempdef2->len+1);
				for (k=0;k<tempdef2->len;k++)
					{
					tempdef2->list_string[k] = read_16ubit(tablefd);
					error(stderr,"str char ? -->%x\n",tempdef2->list_string[k]);
					}
				tempdef2->list_string[k] = '\0';
				}
			}
		error(stderr,"\n"); 
		}
	}

void decode_simple_footer(FILE *mainfd,FILE *tablefd,U32 fcClx,U32 fcMin,U32 fcMac,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int flag)
	{
	U32 headerpos;
	U32 oldccpText;
	U32 begin=0;
	U32 len=0;
	int tempcp;
	int i;
	int footnoteflag=0;
	field_info *tempfields;
	
	if (header == 0)
		{
		error(stderr,"doing footer\n");

		for (i=0;i<portions->list_foot_no;i++)
			{
			decode_footnote(&begin,&len,portions,i);

			if ((begin != -1) && (len != -1))
				{
				if (footnoteflag == 0)
					{
					printf("\n<hr width=\"25%%\">\n");
					footnoteflag=1;
					}
				error(stderr,"beginning footnote\n");
				if (!insuper)
					printf("<sup>");
				printf("<a name=\"foot%d\">",i);

				if (portions->fndFRD[i] > 0)
					printf("%d",portions->fndFRD[i]);
				else
					{
					/*dont bother handling custom footnotes for now*/
					printf("ftn");
					}
				printf("</a>");
				if (!insuper)
					printf("</sup>");

				headerpos = ftell(mainfd);
				oldccpText = portions->ccpText;
				header++;
				fseek(mainfd,portions->fcMin+oldccpText+begin,SEEK_SET);
				tempcp=cp;
				portions->ccpText = len;
				cp=begin;
				tempfields = all_fields[0];
				all_fields[0] = all_fields[2];
				decode_simple(mainfd,tablefd,fcClx,portions->fcMin+oldccpText+begin,fcMac,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,2);
				all_fields[0] = tempfields;
				cp=tempcp;
				fseek(mainfd,headerpos,SEEK_SET);
				portions->ccpText = oldccpText;
				header--;
				error(stderr,"ending footnote\n");
				}
			}
		portions->list_foot_no=0; /*ready for next page footnotes*/
		
		decode_footer(&begin,&len,portions);
		if ((begin != -1) && (len != -1))
			{
			headerpos = ftell(mainfd);
			oldccpText = portions->ccpText;
			header++;
			fseek(mainfd,portions->fcMin+portions->ccpFtn+oldccpText+begin,SEEK_SET);
			tempcp=cp;
			portions->ccpText = len;
			cp=begin;
			tempfields=all_fields[0];
			all_fields[0] = all_fields[1];
			decode_simple(mainfd,tablefd,fcClx,portions->fcMin+oldccpText+portions->ccpFtn+begin,fcMac,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,1);
			all_fields[0] = tempfields;
			cp=tempcp;
			fseek(mainfd,headerpos,SEEK_SET);
			portions->ccpText = oldccpText;
			header--;
			error(stderr,"ending footer\n");
			}

		printf("\n<hr>\n");
		pagenumber++;
		sectionpagenumber++;
		}
	}

void decode_simple_header(FILE *mainfd,FILE *tablefd,U32 fcClx,U32 fcMin,U32 fcMac,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int flag)
	{
	U32 headerpos;
	U32 oldccpText;
	U32 begin=0;
	U32 len=0;
	int tempcp;
	field_info *tempfields;
	int i;

	if (header == 0)
		{
		error(stderr,"doing header\n");
		for (i=0;i<1;i++)
			{
			if (i==0)
				decode_header(&begin,&len,portions);
#if 0
			/*
			im ignoring this for now, i think this is
			a header textbox, so ill hold off on this 
			until i get it right
			*/
			else
				decode_header2(&begin,&len,portions);
#endif
				
			if ((begin != -1) && (len != -1))
				{
				headerpos = ftell(mainfd);
				oldccpText = portions->ccpText;
				header++;
				fseek(mainfd,portions->fcMin+portions->ccpFtn+oldccpText+begin,SEEK_SET);
				tempcp=cp;
				portions->ccpText = len;
				cp=begin;
				tempfields = all_fields[0];
				all_fields[0] = all_fields[1];
				decode_simple(mainfd,tablefd,fcClx,portions->fcMin+oldccpText+portions->ccpFtn+begin,fcMac,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,1);
				all_fields[0] = tempfields;
				cp=tempcp;
				fseek(mainfd,headerpos,SEEK_SET);
				portions->ccpText = oldccpText;
				header--;
				error(stderr,"ending header\n");
				}
			}

		}
	}

void decode_simple(FILE *mainfd,FILE *tablefd,U32 fcClx,U32 fcMin,U32 fcMac,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int flag)
	{
	U32 arse;
	U32 nextfc=0;
	U32 tapfc1=0;
	
	U32 nextchpfc=0;
	U32 lastfc=0;
	U32 lastchpfc=0;
	pap *apap;
	chp *achp;
	pap *tappap;
	pap *temppap = NULL;
	chp *tempchp = NULL;
	int i;
	int letter;
	int tempfck;
	int newpage=1;
	

	U32 *rgfc=NULL;
	U32 *avalrgfc=NULL;
	U16 *sprm=NULL;
	U32 clxcount=0;
	int nopieces;

	U32 untilfc;

	int flag_8_16;

	int d_count=0;
	

	apap = NULL;
	achp = NULL;
	nextfc=fcMin;
	nextchpfc=fcMin;


	error(stderr,"all text begins %ld %x ends at %ld %x, main text ends at %ld\n",fcMin,fcMin,fcMac,fcMac,portions->ccpText+fcMin);


	fseek(tablefd,fcClx,SEEK_SET);
	getc(tablefd);
		
	error(stderr,"begin simple fcClx is (%x)",fcClx);
	nopieces = get_piecetable(tablefd,&rgfc,&avalrgfc,&sprm,&clxcount);
	if (nopieces > 1)
		error(stderr,"hmm, this shouldnt happen\n");
	if (avalrgfc[0] & 0x40000000UL)
		{
		flag_8_16=0;
		untilfc=fcMin+portions->ccpText;
		error(stderr,"hokay, simple text is ascii 8 bit stuff\n");
		}
	else
		{
		flag_8_16=1;
		untilfc=fcMin+portions->ccpText+portions->ccpText;
		error(stderr,"hokay, simple text is unicode 16 bit stuff\n");
		if (header == 0)
			printf("\n<head>\n<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;charset=utf-8\">\n</head>\n");
		}

	if (header == 0)
		printf("<body>\n");

		
	error(stderr,"end simple fcClx is (%x)",fcClx);

	/*for (i=fcMin;i<fcMin+portions->ccpText;i++)*/
	i=fcMin;
	error(stderr,"end fc is %x\n",fcMin+portions->ccpText);

	if (flag)
		untilfc=-1;  /*max it out for header/footers and rely on doubled 0x0d's*/

	while(i<untilfc)
		{
		/*
		go down through all the text, when we hit a new page spit out the 
		header
		*/
		error(stderr,"fc is %ld (%X)\n",i,i);
		if (newpage)
			{
			newpage=0;
			decode_simple_header(mainfd,tablefd,fcClx,fcMin,fcMac,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,flag);
			error(stderr,"end: flag is %d\n",flag);
			/*force new paragraph and chp check*/
			nextfc=i;
			}

		/*get the pap*/
		if (i == nextfc) 
			{
			lastfc = i;
			temppap = apap;
			tempfck = find_FKPno_papx(i,plcfbtePapx,intervals);
			if (tempfck != -1)
				{
				apap = get_pap(tempfck,mainfd,i,&nextfc,sheet,a_list_info);
				error(stderr,"next para is at %x\n",nextfc);
				}
			
			if (apap == NULL)
				{
				error(stderr,"found no pap, reverting to previous\n");
				apap = temppap;
				}
			else if (temppap != NULL)
				{
				free(temppap);
				}

			/*if table set search for tap*/
			if (apap->fInTable)
				{
				tapfc1 = i;
				error(stderr,"we search for the tap here\n");
				error(stderr,"tappap nexts are %x, i is %x\n",tapfc1,i);
				do
					{
					error(stderr,"tappap nexts are %x\n",tapfc1);
					tempfck = find_FKPno_papx(tapfc1,plcfbtePapx,intervals);
					if (tempfck != -1)
						tappap = get_pap(tempfck,mainfd,tapfc1,&tapfc1,sheet,a_list_info);
					else
						break;
					}
				while( (!tappap->fTtp) && (tappap != NULL) );
				error(stderr,"finished search for the tap here\n");
				/*
				at this stage tappap has the correct row structure stored in it
				that we want apap to have
				*/
				apap->ourtap = tappap->ourtap;
				}
			}

		/* get the chp, using the paps istd for a basis*/
		if ((i == nextchpfc) || (lastfc == i)) 
			{
			lastchpfc=i;
			error(stderr,"looking for chp\n");
			tempchp = achp;
			tempfck = find_FKPno_chpx(i,plcfbteChpx,chpintervals);
			if (tempfck != -1)
				achp = get_chp(tempfck,mainfd,i,&nextchpfc,sheet,apap->istd);

			if (achp == NULL)
				{
				error(stderr,"found no chp, reverting to previous\n");
				achp = tempchp;
				}
			else if (tempchp != NULL)
				free(tempchp);

			if (flag == 1)
				{
				achp->color="#7f5555";
				error(stderr,"color set\n");
				}
			else if (flag == 2)
				{
				achp->color="#330099";
				error(stderr,"color set\n");
				}
			else 
				{
				error(stderr,"color not set\n");
				}

			error(stderr,"the next char lim is %d (%x)\n",nextchpfc,nextchpfc);
			
			decode_e_list(apap,achp,a_list_info);
			decode_e_chp(achp);
			}
			
		/*after we have a new pap, do the special codes*/
		if (lastfc == i)
			{
			decode_e_specials(apap,achp,a_list_info);
			decode_e_table(apap,achp,a_list_info);
			decode_s_table(apap,achp,a_list_info);
			decode_s_specials(apap,achp,a_list_info);
			}

		if (lastchpfc == i) 
			{
			decode_s_chp(achp);
			lastchpfc = 0;
			}


		if (flag_8_16)
			letter = read_16ubit(mainfd);
		else
			letter = getc(mainfd);


		if (lastfc == i)
			{
			if ( (letter != 12) && (letter != 13) )
				decode_s_list(apap,achp,a_list_info,fontnamelist);
			lastfc = 0;
			}

		if (flag)
			{
			if (letter == 13)
				{
				/*
				headers and footers seem to continue until 2 0x0d are reached, they dont
				appear after all to go until the len derived from the header table
				like i thought originally.
				*/
				d_count++;
				if (d_count == 2)
					break;
				}
			else
				d_count=0;
			}

		newpage = decode_letter(letter,flag_8_16,apap,achp,all_fields[0],mainfd,fontnamelist,a_list_info,portions);

		if (newpage)
			decode_simple_footer(mainfd,tablefd,fcClx,fcMin,fcMac,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,flag);
			
		if (flag_8_16)
			i+=2;
		else
			i++;
		}

	if (apap == NULL)
		{
		apap = (pap *)malloc(sizeof(pap));
		if (apap == NULL)
			return;
		}
	
	apap->istd = 0;
	apap->ilvl=-1;
	apap->tableflag=0;
	decode_e_list(apap,achp,a_list_info);
	decode_e_specials(apap,achp,a_list_info);
	decode_e_table(apap,achp,a_list_info);
	if (apap !=NULL)
		free(apap);
	if (achp !=NULL)
		free(achp);

	if (!newpage)
		decode_simple_footer(mainfd,tablefd,fcClx,fcMin,fcMac,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,flag);
	}


void decode_header(U32 *begin,U32 *len,textportions *portions)
	{
	/*i dont know how these fields are working as of yet, the
	docs seem to be a bit dodgy*/
	*begin = -1;
	*len= -1;

	/*is this the first page of a section*/
	if (sectionpagenumber==1)
		{
		error(stderr,"checking for page 1 special header\n");
		if (portions->headercpno > 10)
			if (portions->headercplist[11] > portions->headercplist[10])
				{
				*begin = portions->headercplist[10];
				*len = portions->headercplist[11]-portions->headercplist[10];
				error(stderr,"header begin is %x end is %x\n",portions->headercplist[11],portions->headercplist[10]);
				return;
				}
		}
	
	/*if nothing was found continue, and pull out ordinary header*/


	/*if index 8 is larger than index 7 i think thats the boundaries
	of header for all pages*/
	if (portions->headercpno > 7)
		if (portions->headercplist[8] > portions->headercplist[7])
			{
			*begin = portions->headercplist[7];
			*len = portions->headercplist[8]-portions->headercplist[7];
			error(stderr,"header begin is %x end is %x\n",portions->headercplist[7],portions->headercplist[8]);
			}
	else
		error(stderr,"well arse!!!, ive got the wrong idea about headers\n");

	}

void decode_header2(U32 *begin,U32 *len,textportions *portions)
	{

	/*
	this is just a hacked together function, i have no basis for
	this at all except thats the output that word gets, dunno at all
	about this, im not seeing something obvious somewhere, hmm
	*/

	/*i dont know how these fields are working as of yet, the
	docs seem to be a bit dodgy*/
	*begin = -1;
	*len= -1;

	/*is this the first page of a section*/
	if (sectionpagenumber==1)
		return;
	
	/*if index 8 is larger than index 7 i think thats the boundaries
	of header for all pages*/
	if (portions->headercpno > 12)
		if (portions->headercplist[13] > portions->headercplist[12])
			{
			*begin = portions->headercplist[12];
			*len = portions->headercplist[13]-portions->headercplist[12];
			error(stderr,"header begin is %x end is %x\n",portions->headercplist[12],portions->headercplist[13]);
			}
	else
		error(stderr,"well arse!!!, ive got the wrong idea about headers\n");

	}

void decode_footnote(U32 *begin,U32 *len,textportions *portions,int i)
	{
	error(stderr,"footnote cp begin is %x end is %x\n",portions->fndTxt[i],portions->fndTxt[i+1]);
	*begin = portions->fndTxt[i];
	*len = portions->fndTxt[i+1]-*begin;
	}

void decode_footer(U32 *begin,U32 *len,textportions *portions)
	{
	/*i dont know how these fields are working as of yet, the
	docs seem to be a bit dodgy*/
	*begin = -1;
	*len= -1;

	if (sectionpagenumber==1)
		{
		error(stderr,"checking for page 1 special footer\n");
		if (portions->headercpno > 12)
			if (portions->headercplist[12] > portions->headercplist[11])
				{
				*begin = portions->headercplist[11];
				*len = portions->headercplist[12]-portions->headercplist[11];
				printf("\n<hr width=\"50%%\">\n");
				error(stderr,"header begin is %x end is %x\n",portions->headercplist[12],portions->headercplist[11]);
				return;
				}
		}

	/*else contunue down the wire*/

	/*if index 10 is larger than index 9 i think thats the boundaries
	of header for all pages*/
	if (portions->headercpno > 9)
		{
		if (portions->headercplist[10] > portions->headercplist[9])
			{
			*begin = portions->headercplist[9];
			*len = portions->headercplist[10]-portions->headercplist[9];
			printf("\n<hr width=\"50%%\">\n");
			error(stderr,"begin is %x end is %x\n",portions->headercplist[9],portions->headercplist[10]);
			}
		}
	else
		error(stderr,"well arse!!!, ive got the wrong idea about footers val %d\n",portions->headercpno);
	}

void decode_s_chp(chp *achp)
	{
	error(stderr,"in start chp\n");
	if (chps)
		return;

	if ((achp->fontsize!=currentfontsize) || ( (achp->color != NULL) && (!inacolor))  || ( (achp->color == NULL) && (inacolor)) )
		{
		error(stderr,"font =%d\n", achp->fontsize);
#if 0
		if (inafont)
			{
			if (initalic)
				{
				printf("</I>");
				initalic=0;
				}
			if (inbold)
				{
				printf("</B>");
				inbold=0;
				}
			if (inunderline)
				{
				printf("</U>");
				inunderline=0;
				}
			inacolor=0;
			printf("</font>");
			}
#endif
		if (initalic)
			{
			printf("</I>");
			initalic=0;
			}
		if (inbold)
			{
			printf("</B>");
			inbold=0;
			}
		if (inunderline)
			{
			printf("</U>");
			inunderline=0;
			}
		if (inafont)
			{
			inacolor=0;
			printf("</font>");
			}

		printf("<font ");
		if ( (((achp->fontsize/2)-NORMAL/2) != 0) && (achp->fontsize!=NORMAL))
			{
			printf("size = \"%+d\" ", (achp->fontsize/2)-NORMAL/2);
			inafont=1;
			}
		if (achp->color != NULL)
			{
			printf("color =\"%s\"", achp->color);
			inafont=1;
			inacolor=1;
			}
		printf(">");
		currentfontsize=achp->fontsize;
		}


	if ((achp->supersubscript == 1) && (!insuper))
		{
		error(stderr,"superscript begins\n");
		printf("<SUP>");
		insuper=1;
		}

	if ((achp->supersubscript == 2) && (!insub))
        {
        error(stderr,"subscript begins\n");
        printf("<SUB>");
        insub=1;
        }

	error(stderr,"bold is %d\n",achp->fBold);

	if ((achp->fBold) && (inbold == 0))
		{
		printf("<B>");
		inbold=1;
		}
	
	if ((achp->fItalic) && (initalic==0))
		{
		printf("<I>");
		initalic=1;
		}


	if ((achp->underline) && (inunderline == 0))
		{
		printf("<U>");
		inunderline=1;
		}
	}

void decode_e_chp(chp *achp)
	{
	error(stderr,"in end chp\n");

	if ((inunderline== 1) && (achp->underline == 0))
		{
		inunderline=0;
		printf("</U>");
		}

	if ((initalic == 1) && (achp->fItalic == 0))
		{
		initalic=0;
		printf("</I>");
		if (inbold==1)
			{
			inbold=0;
			printf("</B>");
			}
		}

	if ((inbold==1) && (!achp->fBold))
		{
		if (initalic == 1)
			{
			initalic=0;
			printf("</I>");
			}
		inbold=0;
		printf("</B>");
		}

	if ((insuper) && (achp->supersubscript != 1))
		{
		insuper=0;
		printf("</SUP>");
		}

	if ((insub) && (achp->supersubscript != 2))
		{
		insub=0;
		printf("</SUB>");
		}

	if ( ((inafont) && (achp->fontsize!=currentfontsize)) || ((inacolor) && (achp->color == NULL)) )
		{
		error(stderr,"font ended\n");
		if (initalic == 1)
			{
			initalic=0;
			printf("</I>");
			}
		if (inbold == 1)
			{
			inbold=0;
			printf("</B>");
			}
		printf("</FONT>");
		inafont =0;
		inacolor=0;
		currentfontsize=NORMAL;
		}
	}

void decode_reference(textportions *portions, FILE *main)
	{
	int i;
	/*
	search in the first thing for the cp of this
	reference, then use this index into the second
	one to determine what text to use ?
	*/
	i=0;
	while(i<portions->fndref_no)
		{
		if (portions->fndRef[i] == cp)
			{
			error(stderr,"found correct ref pos at %x, index was %d\n",portions->fndRef[i],i);
			if (!insuper)
				printf("<sup>");
			if (portions->fndFRD[i] > 0)
				{
				error(stderr,"is autonumbered <%d>\n",portions->fndFRD[i]);
				printf("<a href=\"#foot%d\">%d</a>",i,portions->fndFRD[i]);
				}
			else
				{
				error(stderr,"is custom <%d>\n",portions->fndFRD[i]);
				/*dont bother handling custom footnotes for now*/
				printf("<a href=\"#foot%d\">ftn</a>",i);
				}
			if (!insuper)
				printf("</sup>");
			break;
			}
		error(stderr,"conpared given pos %x and ref list %x",cp,portions->fndRef[i]);
		i++;
		}

	/*part deux*/
	/*
	now to hold off to the very end any spray them all out, or at the end of every page.
	ill do the latter for the moment
	*/
	if ( (i < portions->fndref_no ) && (i < 256) )
		portions->list_footnotes[portions->list_foot_no++] = i;
	else if (i >= 256)
		fprintf(stderr,"oops silly programmer :-) lost a footnote\n");
	}


void flushbreaks(void)
	{
	int silent=0,i;

	if (breakcount == 1)
		{
		oprintf(silent,"<br>\n");
		}
	else if (breakcount > 1)
		{
		if (verpadding == 1)
			{
			for (i=0;i<breakcount;i++)
				oprintf(silent,"<br>\n");
			}
		else
			{
			oprintf(silent,"<p>\n");
			if (verpadding != 2)
				if (breakcount > 2)
					for (i=2;i<breakcount;i++)
						oprintf(silent,"<br>\n");
			}
		}
	breakcount=0;
	}

int decode_letter(int letter,int flag,pap *apap, chp * achp,field_info *magic_fields,FILE *main,ffn *fontnamelist,list_info *a_list_info,textportions *portions)
	{
	int ret=0;
	int i;
	static U8 fieldwas=-1;
	static fieldeater=0;
	static long int swallowcp1=-1,swallowcp2=-1;
	static int spacecount;
	static int tabstop;
	static int silent=0;
	float tabbing;
	ffn *tempfont;
	
	U8 target[7];
	int len;

	chp tempchp;


	if  (letter != 13 || achp->fontcode !=0 ) 
		flushbreaks();
	
	if (fontnamelist != NULL)
		{
		if ( (achp->fontcode !=0) && (letter > 34) ) 
			{
			error(stderr,"asked for nonstandard font %d\n",achp->fontcode);
			i=0;
			tempfont = fontnamelist;
			while (i < achp->fontcode)
				{
				tempfont = tempfont->next;
				if (tempfont == NULL)
					break;
				i++;
				}

			if (tempfont == NULL)
				{
				error(stderr,"warning!! fontcode incorrect, abandoning\n");
				return(0);
				}

			error(stderr,"i is %d and font is %s\n",i,tempfont->name);
			if (i == achp->fontcode)
				{
				if (!(strcmp("Symbol",tempfont->name)))
					{
					error(stderr,"must use symbol font for this letter\n");
					if (decode_symbol(achp->fontspec))
						{
						cp++;
						return(ret);
						}
					}
				else if (!(strcmp("Wingdings",tempfont->name)))
					{
					error(stderr,"must use wingding font for this letter %c\n",letter);
					if (decode_wingding(achp->fontspec))
						{
						cp++;
						return(ret);
						}
					}
				}
			}
		else 
			{
			i=0;
			tempfont = fontnamelist;
			while (i < achp->ascii_font)
				{
				tempfont = tempfont->next;
				if (tempfont == NULL)
					break;
				i++;
				}
			error(stderr,"i is %d and font is %s\n",i,tempfont->name);
			if (i == achp->ascii_font)
				{
				if (!(strcmp("Symbol",tempfont->name)))
					{
					error(stderr,"must use symbol font for this letter here\n");
					if (decode_symbol(letter))
						{
						cp++;
						return(ret);
						}
					}
				else if (!(strcmp("Wingdings",tempfont->name)))
					{
					error(stderr,"must use wingding font for this letter here %d\n",letter);
					if (decode_wingding(letter))
						{
						cp++;
						return(ret);
						}
					}
				}

			}
		}

	error(stderr,"cp is %x (%x)\n",cp,letter);
	if ( (fieldeater > 0) && (letter == 0x20) )
		{
		fieldeater--;
		if (fieldeater == 0)
			silent=0;
		}
	else if ((cp >= swallowcp1) && (cp < swallowcp2))
		{
		error(stderr,"swallowing %c\n",letter);
		}
	else
		{
		if ((letter != 32) && (spacecount == 1))
			{
			oprintf(silent," ");
			spacecount=0;
			tabstop++;
			}
		else if (letter != 32) 
			{
			for (i=0;i<spacecount;i++)
				{
				if (padding)
					oprintf(silent,"&nbsp;");
				tabstop++;
				}
			spacecount=0;
			}


		tabstop++;

		switch(letter)
			{
			case 13:
				error(stderr,"\n--paragraph end--\n");
				if (!silent)
					{
					breakcount++;
	/*				
					oprintf(silent,"<P>\n");
	*/
					tabstop=0;
					newline=1;
					}
				break;
			case 11:
				error(stderr,"\n(--line break--)\n");
				oprintf(silent,"<BR>\n");
				tabstop=0;
				break;
			case 45:
				error(stderr,"-");
				oprintf(silent,"-"); 
				break;
			case 32:
				spacecount++;
				/*printf(" ");*/
				tabstop--;
				break;
			case 31:
				error(stderr,"\n(-nonrequired hyphen- ?)\n");
				oprintf(silent,"-");
				break;
			case 30:
				error(stderr,"\n(-nonbreaking hyphen- ?)\n");
				oprintf(silent,"-");
				break;
			case 160:
				error(stderr,"\n(-non breaking space)\n");
				oprintf(silent,"&nbsp;");
				break;
			case 12:
				error(stderr,"\npage break (maybe section\n");
				ret=1;
				/*oprintf(silent,"<hr>");*/
				tabstop=0;
				break;
			case 14:
				error(stderr,"\ncolumn break\n");
				break;
			case 9:
				tabstop--;
				error(stderr,"\ntab\n");
				tabbing = ((float)tabstop)/8;
				error(stderr,"tabbing is %f, from %d\n",tabbing,tabstop);
				if (tabbing == tabstop/8)
					{
					if (padding)
						oprintf(silent,"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
					tabstop = tabstop=8;
					}
				else 
					{
					for(i=0;i< 8-((tabbing - (tabstop/8))*8);i++)
						{
						if (padding)
							oprintf(silent,"&nbsp;");
						}
					tabstop = tabstop+(8-(tabbing - (tabstop/8))*8);
					}
				/*oprintf(silent,"<TAB>");*/
				break;
			case 19:
				error(stderr,"\nfield begins\n");
				init_chp(&tempchp);
				chpsoff();
				decode_field(main,magic_fields,&cp,&fieldwas,&swallowcp1,&swallowcp2);
				error(stderr,"cp vals are %x and %x\n",swallowcp1,swallowcp2);
				if (fieldwas == 88)
					fieldeater=2; /*eat 2 hex 20's*/
				silent=1;
				break;
			case 21:
				error(stderr,"\nfield ends\n");
				decode_field(main,magic_fields,&cp,&fieldwas,&swallowcp1,&swallowcp2);
				chpson();
				silent=0;
				break;
			case '<':
				oprintf(silent,"&lt;");
				break;
			case '>':
				oprintf(silent,"&gt;");
				break;
			case 20:
				error(stderr,"\n field separator\n");
				decode_field(main,magic_fields,&cp,&fieldwas,&swallowcp1,&swallowcp2);
				if ( (fieldwas == 29) || (fieldwas == 13) )
					silent=0;
				break;
			case 7:
				apap->tableflag=1;
				decode_e_specials(apap,achp,a_list_info);
				decode_e_table(apap,achp,a_list_info);
				error(stderr,"\n");
				break;
			case 2:
				if (achp->fSpec == 1)
					{
					error(stderr,"INSERT REF\n");
					decode_reference(portions,main);
					}
				else
					error(stderr,"ordinary char 2\n");
				break;
			case 0x96:
				oprintf(silent,"-");
				break;
			case 145:
			case 146:
				oprintf(silent,"'");
				break;
			case 132:
			case 147:
				error(stderr,"begin quot\n");
				oprintf(silent,"&quot;");
				break;
			case 148:
				error(stderr,"end quot\n");
				oprintf(silent,"&quot;");
				break;
			default:
				if (flag)
					{
					len = our_wctomb(target,letter);
					for(i=0;i<len;i++)
						{
						oprintf(silent,"%c",target[i]);
						error(stderr,"letter2: %c",target[i]);
						}
					}
				else
					{
					oprintf(silent,"%c",letter);
					error(stderr,"letter2: %c %d %x",letter,letter,letter);
					}
				break;
			}
		}
	cp++;
	return(ret);
	}

int get_piecetable(FILE *in,U32 **rgfc,U32 **avalrgfc,U16 **sprm,U32 *clxcount)
	{
	U32 lcb;
	int nopieces=0;
	int i;
	U32 aval;

	lcb = read_32ubit(in);
	(*clxcount)+=(lcb+4);
	nopieces = (lcb-4)/12;
	error(stderr,"lcb is %ld, theres %d pieces\n",lcb,nopieces);

	if ((*rgfc) != NULL)
		free((*rgfc));
	if ((*avalrgfc) != NULL)
		free((*avalrgfc));
	if ((*sprm)!= NULL)
		free((*sprm));
	*rgfc = (U32 *) malloc((nopieces +1) * sizeof(U32));
	*avalrgfc = (U32 *) malloc((nopieces) * sizeof(U32));
	*sprm = (U16 *)  malloc((nopieces) * sizeof(U16));

	if ((*rgfc) == NULL)
		{
		error(stderr,"qar\n");
		exit(-1);
		}
	if ((*avalrgfc) == NULL)
		{
		error(stderr,"qar\n");
		exit(-1);
		}
	if ((*sprm) == NULL)
		{
		error(stderr,"qar\n");
		exit(-1);
		}

	for(i=0;i<nopieces+1;i++)
		{
		(*rgfc)[i] = read_32ubit(in);
		error(stderr," array entry is %x\n",(*rgfc)[i]);
		}

	for(i=0;i<nopieces;i++)
		{
		aval = read_16ubit(in);
		(*avalrgfc)[i] = read_32ubit(in);
		error(stderr,"file offsets of pieces are (%x)\n",(*avalrgfc)[i]);
		(*sprm)[i] = read_16ubit(in);
		error(stderr,"TOUGH: the sprm referenced here is %d\n",(*sprm)[i]);
		if ((*sprm)[i] & 0x01)
			error(stderr,"sprm varient 2\n");
		else
			error(stderr,"sprm varient 1\n");
		}
	return(nopieces);
	}

void decode_clx_footer(U32 *rgfc,int nopieces,U32 startpiece,U32 begincp,U32 endcp,FILE *in,FILE *main,U32 fcClx,U32 lcbClx,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int headerfooterflag)
	{
	U32 oldtablepos;
	U32 oldmainpos;
	U32 tempcp;
	U32 begin=0;
	U32 len=0;
	int k;
	field_info *tempfields;
	int i;
	int footnoteflag=1;

	if (header == 0)
		{
		for (i=0;i<portions->list_foot_no;i++)
			{
			decode_footnote(&begin,&len,portions,i);

			if ((begin != -1) && (len != -1))
				{
				if (footnoteflag == 0)
					{
					printf("\n<hr width=\"25%%\">\n");
					footnoteflag=1;
					}
				error(stderr,"beginning footnote\n");
				if (!insuper)
					printf("<sup>");
				printf("<a name=\"foot%d\">",i);

				if (portions->fndFRD[i] > 0)
					printf("%d",portions->fndFRD[i]);
				else
					{
					/*dont bother handling custom footnotes for now*/
					printf("ftn");
					}
				printf("</a>");
				if (!insuper)
					printf("</sup>");

				oldmainpos = ftell(main);
				oldtablepos = ftell(in);
				header++;

				k=0;
				while (k< nopieces)
					{
					if (portions->ccpText+begin < rgfc[k]) 
						{
						error(stderr,"piece for footer is %d (%x) (%x)\n",k-1,rgfc[k-1],portions->ccpText+begin);
						break;
						}
					k++;
					}
				tempcp=cp;
				cp=begin;
				error(stderr,"the difference is %d\n",(portions->ccpText+begin)-rgfc[k-1]);
				cp = cp-((portions->ccpText+begin)-rgfc[k-1]);
				error(stderr,"footer len is %d\n",len);
				error(stderr,"footer cp is %x\n",cp);
				tempfields = all_fields[0];
				all_fields[0] = all_fields[2];
				decode_clx(k-1,begin,begin+len,in,main,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,1);
				all_fields[0] = tempfields;
				cp=tempcp;
				fseek(in,oldtablepos,SEEK_SET);
				fseek(main,oldmainpos,SEEK_SET);
				header--;
				}
			}
		portions->list_foot_no=0; /*ready for next page footnotes*/
		
		decode_footer(&begin,&len,portions);
		if ((begin != -1) && (len != -1))
			{
			header++;
			error(stderr,"doing footer\n");

			oldmainpos = ftell(main);
			oldtablepos = ftell(in);
			error(stderr,"decoding footer clx 1\n");
			error(stderr,"the cp of begin of the header is probably cps (%x) to (%x)", portions->ccpText,portions->ccpText+portions->ccpFtn+portions->ccpHdd);
			k=0;
			while (k< nopieces)
				{
				if (portions->ccpText+portions->ccpFtn+begin < rgfc[k]) 
					{
					error(stderr,"piece for this footer is %d (%x) (%x)\n",k-1,rgfc[k-1],portions->ccpText+portions->ccpFtn+begin);
					break;
					}
				k++;
				}
			tempcp=cp;
			cp=begin;
			error(stderr,"the difference is %d\n",(portions->ccpText+portions->ccpFtn+begin)-rgfc[k-1]);
			cp = cp-((portions->ccpText+portions->ccpFtn+begin)-rgfc[k-1]);
			error(stderr,"footer len is %d\n",len);
			error(stderr,"footer cp is %x\n",cp);
			tempfields = all_fields[0];
			all_fields[0] = all_fields[1];
			decode_clx(k-1,begin,begin+len,in,main,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,1);
			all_fields[0] = tempfields;
			cp = tempcp;
			fseek(in,oldtablepos,SEEK_SET);
			fseek(main,oldmainpos,SEEK_SET);
			header--;
			}
		error(stderr,"ending footer\n");
		printf("\n<hr>\n");
		pagenumber++;
		sectionpagenumber++;
		}
	}

void decode_clx_header(U32 *rgfc,int nopieces,U32 startpiece,U32 begincp,U32 endcp,FILE *in,FILE *main,U32 fcClx,U32 lcbClx,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style *sheet,textportions *portions,ffn *fontnamelist,int headerfooterflag)
	{
	U32 oldtablepos;
	U32 oldmainpos;
	U32 tempcp;
	U32 begin=0;
	U32 len=0;
	int k;
	field_info *tempfields;

	if (header == 0)
		{
		decode_header(&begin,&len,portions);
		if ((begin != -1) && (len != -1))
			{
			header++;
			oldmainpos = ftell(main);
			oldtablepos = ftell(in);
			error(stderr,"decoding header\n");
			error(stderr,"the cp of begin of the header is probably cps (%x) to (%x)", portions->ccpText+portions->ccpFtn+begin,portions->ccpText+portions->ccpFtn+begin+len);
			k=0;
			while (k< nopieces)
				{
				if (portions->ccpText+portions->ccpFtn+begin < rgfc[k]) 
					{
					error(stderr,"piece for header is %d (%x) (%x)\n",k-1,rgfc[k-1],portions->ccpText+portions->ccpFtn+begin);
					break;
					}
				k++;
				}
			tempcp=cp;
			cp=begin;
				cp = cp+(portions->ccpText+portions->ccpFtn+begin)-rgfc[k-1];
			error(stderr,"header cp is %x\n",cp);
			tempfields = all_fields[0];
			all_fields[0] = all_fields[1];
			decode_clx(k-1,begin,begin+len,in,main,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,1);
			all_fields[0] = tempfields;
			cp = tempcp;
			fseek(in,oldtablepos,SEEK_SET);
			fseek(main,oldmainpos,SEEK_SET);
			header--;
			}
		}
	}

void init_chp(chp * achp)
	{
	achp->fBold=0;
	achp->fItalic=0;
	achp->ascii_font=0;
	achp->eastfont=0;
	achp->noneastfont=0;
	achp->fontsize=NORMAL;
	achp->supersubscript=0;
	achp->fontcode=0;
	achp->fontspec=0;
	achp->fSpec=0;
	achp->color=NULL;
	achp->underline=0;
	}

void decode_clx(U32 startpiece,U32 begincp,U32 endcp,FILE *in,FILE *main,U32 fcClx,U32 lcbClx,U32 intervals,U32 chpintervals,U32 *plcfbtePapx,U32 *plcfbteChpx,field_info *all_fields[3],list_info *a_list_info,style * sheet,textportions *portions, ffn *fontnamelist,int headerfooterflag)
	{
	int paraendpiece;
	int index=0;
	pap *apap=NULL;
	pap *tappap=NULL;
	pap *temppap=NULL;
	chp *achp=NULL;
	long pos = ftell(in);
	long mainpos = ftell(main);
	int i;
	int k;
	U32 tapfc1=0;
	U32 tapfc2=0;
	
	U8 clxt;
	U16 cb;
	U16 *sprm=NULL;
	
	
	int j=0;
	int nopieces=0;
	U32 *rgfc=NULL;
	U32 *avalrgfc=NULL;
	int letter;
	int hack=0;
	U32 nextfc;
	U32 chpnextfc;
	U32 clxcount=0;
	Sprm asprmlist;
	Sprm *psprmlist=&asprmlist;
	U32 lastfc=0;
	U32 lastchpfc=0;
	static metadone=0;

	int newpage=1;
	
	
	
	

	int notfinished=1;
	int fccount;
	

	int d_count=0;

	fseek(in,fcClx,SEEK_SET);
	error(stderr,"seeking table to (%x) len %d\n",fcClx,lcbClx);
	while ((clxcount < lcbClx) && (notfinished))
		{
		clxt = getc(in);
		clxcount++;
		error(stderr,"clxt is %d\n",clxt);

		psprmlist->list=NULL;
		psprmlist->next=NULL;
		psprmlist->len=0;

		if (clxt == 1)
			{
			/*make a list of of these gprrls*/
			/*decode them when fetched in clxt==2*/
			/*use bitfields to skip ones i dont care about*/
			error(stderr,"contains  grpprl\n");
			cb = read_16ubit(in);
			error(stderr,"cb is %d\n",cb);
			psprmlist->list = (U8 *) malloc(cb);
			if (psprmlist->list == NULL)
				{
				fprintf(stderr,"mem barfoid\n");
				exit(-1);
				}

			clxcount+=(cb+2);
			psprmlist->len=cb;
			for(i=0;i<cb;i++)
				psprmlist->list[i] = getc(in);
			psprmlist->next = (Sprm *) malloc(sizeof(Sprm));
			if (psprmlist->next == NULL)
				{
				fprintf(stderr,"mem barfoid\n");
				exit(-1);
				}
			psprmlist = psprmlist->next;
			index++;
			error(stderr,"on gp no %d\n",index);
			}
		else if (clxt == 2)
			{
			index =0;
			error(stderr,"contains  Plcfpcd\n");
			
			nopieces = get_piecetable(in,&rgfc,&avalrgfc,&sprm,&clxcount);


			/*guess based on first piece whether to go utf 8 or not*/
			/*
			actually doing utf8 all the time on complex docs as it
			turns out not to be such a good test :-(
			*/

			if ( (header == 0) && (metadone == 0) )
				{
				printf("\n<head>\n<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html;charset=utf-8\">\n</head>\n");
				metadone=1;
				}

			for(i=startpiece/*start piece*/;i<nopieces;i++)
				{

				if ((header == 0) && (metadone ==0))
					{
					printf("<body>\n");
					metadone=1;
					}

				if (notfinished == 0)
					break;

				if (newpage)
					{
					newpage =0;
					decode_clx_header(rgfc,nopieces,startpiece,begincp,endcp,in,main,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,headerfooterflag);
					}			


				/*push this val back as its something else*/
				if (avalrgfc[i] & 0x40000000UL)
					{
					avalrgfc[i] = avalrgfc[i] & 0xbfffffffUL;
					avalrgfc[i] = avalrgfc[i]/2;
					error(stderr,"tricky ? seek val (%x)\n",avalrgfc[i]);
					error(stderr,"seeking main to (the FC %x) for len %d\n",avalrgfc[i],rgfc[i+1]-rgfc[i]);
					hack=1;
					}
				else
					{
					error(stderr,"seeking main to (the FC %x) for len %d piece %d\n",avalrgfc[i],rgfc[i+1]-rgfc[i],i);
					hack=0;
					}
				fseek(main,avalrgfc[i],SEEK_SET);
				error(stderr,"piece entry fc is %x sprm is %x len is %d\n",avalrgfc[i],sprm[i],rgfc[i+1]-rgfc[i]);

				temppap = apap;
				apap = NULL;
				error(stderr,"getting 1 pap\n");
				apap = get_complex_pap(avalrgfc[i],plcfbtePapx,i,nopieces,intervals,rgfc,main,avalrgfc,&nextfc,NULL,&paraendpiece,sheet,a_list_info);
				error(stderr," the next para is at (%x)\n",nextfc);
				if (apap == NULL)
					{
					error(stderr,"we failed in out attempt to get a paragraph\n");
					if (temppap == NULL)
						{
						apap = (pap *) malloc(sizeof(pap));
						if (apap == NULL)
							{
							fprintf(stderr,"no mem aieee\n");
							exit(-1);
							}
						apap->istd = 0;
						apap->fInTable = 0;
						apap->fTtp= 0;
						apap->ilvl = -1;
						apap->ilfo = -1; /*index into hpllfo*/
						apap->tableflag=0;
						apap->list_data=NULL;
						}
					else
						{
						error(stderr,"using previous pap\n");
						apap = temppap;
						temppap = NULL;
						}
					}
				else
					{
					if (temppap != NULL)
						free(temppap);
					temppap = NULL;

					/*begin tappap search*/
					/*if we're in a table search for the one with fTtp*/

					if (apap->fInTable)
						{
						k = i;
						do
							{
							tapfc1 = avalrgfc[k];
							error(stderr,"1. we search for the tap here\n");
							error(stderr,"tappap nexts are %x, k is %x\n",tapfc1,k);
							do
								{
								error(stderr,"tappap nexts are %x %x\n",tapfc1,avalrgfc[k+1]);
								tapfc2 = tapfc1;
								tappap = get_complex_pap(tapfc1,plcfbtePapx,k,nopieces,intervals,rgfc,main,avalrgfc,&tapfc1,NULL,&paraendpiece,sheet,a_list_info);
								}
							while( (!tappap->fTtp) && (tappap != NULL) && (tapfc1 != tapfc2)) ;
							k++;
							}
						while ( (!tappap->fTtp) && (tappap != NULL) && (k<nopieces) );
						/*
						at this stage tappap has the correct row structure stored in it
						that we want apap to have
						*/
						apap->ourtap = tappap->ourtap;
						error(stderr,"finished search for the tap here\n");
						error(stderr,"no of cells is %d, %d\n",apap->ourtap.cell_no,tappap->ourtap.cell_no);
						}

					/*end tappap search*/
					
					}
				
				error(stderr,"AT THIS POINT %d\n",apap->istd);
				
				achp = get_complex_chp(avalrgfc[i],plcfbteChpx,i,nopieces,chpintervals,rgfc,main,avalrgfc,&chpnextfc,sheet,apap->istd);
				error(stderr," CHP: the next para is at (%x)\n",chpnextfc);
				if (achp == NULL)
					{
					error(stderr,"we failed in out attempt to get a chp\n");
					achp = (chp *) malloc(sizeof(chp));
					if (achp == NULL)
						{
						fprintf(stderr,"no mem aieee\n");
						exit(-1);
						}
					init_chp(achp);

					}

				if (headerfooterflag == 1)
					achp->color="#7f5555";
				else if (headerfooterflag == 2)
					achp->color="#330099";

				/*
				the gpprl that id added is the one that belongs to the 
				piece that has the paragraph mark
				*/
				
				error(stderr,"decoding gpprl with (%x) index %d\n",sprm[paraendpiece],paraendpiece);
				decode_gpprls(apap,achp,sprm,paraendpiece,&asprmlist,sheet);
				error(stderr,"1) ilfo is %d\n",apap->ilfo);
				decode_e_list(apap,achp,a_list_info);
				decode_e_chp(achp);
				decode_e_specials(apap,achp,a_list_info);
				decode_e_table(apap,achp,a_list_info);
				decode_s_table(apap,achp,a_list_info);
				decode_s_specials(apap,achp,a_list_info);
				decode_s_chp(achp);

				error(stderr,"2) ilfo is %d\n",apap->ilfo);
				j=0;
				/*
				if ( (j==0) && (letter != 12) && (letter != 13) )
					{
					decode_s_list(apap,achp,a_list_info,fontnamelist);
					error(stderr,"finished list hwew\n");
					}
				*/

				/*this are the count of elements (can be both 8 and 16 bit)*/

				fccount=avalrgfc[i]-1;
				error(stderr,"fcount is %x pos is %x\n",fccount,ftell(main));
				/*this is the actual file position, always in bytes*/
				while(j<rgfc[i+1]-rgfc[i])
					{
					if (newpage)
						{
						if (header == 0)
							{
							newpage =0;
							decode_clx_header(rgfc,nopieces,startpiece,begincp,endcp,in,main,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,headerfooterflag);
							}
						}			

					if (!hack)
						{
						letter = read_16ubit(main);
						fccount+=2;	
						}
					else
						{
						letter = getc(main);
						fccount++;
						}

					if ( (j==0) && (letter != 12) && (letter!=13) )
						{
						decode_s_list(apap,achp,a_list_info,fontnamelist);
						error(stderr,"finished list hwew letter was %d %x\n",letter,letter);
						}


					if (fccount >= nextfc)
						{
						lastfc = nextfc;
						error(stderr,"the fc is (%x) and the first fc after end of para is (%x)",fccount,nextfc);
						error(stderr,"so im looking for the pap again\n");
						if (apap != NULL)
							{
							temppap = apap;
							apap = NULL;
							}
						error(stderr,"getting 2 pap\n");
						apap = get_complex_pap(fccount,plcfbtePapx,i,nopieces,intervals,rgfc,main,avalrgfc,&nextfc,NULL,&paraendpiece,sheet,a_list_info);
						error(stderr,"the nextfc for pap one is at %x\n",nextfc);

						if (apap == NULL)
							{
							if (temppap != NULL)
								{
								error(stderr,"we failed in out attempt to get a paragraph\n");
								if (temppap == NULL)
									{
									apap = (pap *) malloc(sizeof(pap));
									if (apap == NULL)
										{
										fprintf(stderr,"no mem aieee\n");
										exit(-1);
										}
									apap->istd = 0;
									apap->fInTable = 0;
									apap->fTtp= 0;
									apap->ilvl = -1;
									apap->tableflag=0;
									apap->ilfo = -1; /*index into hpllfo*/
									apap->list_data=NULL;
									}
								else
									{
									error(stderr,"using previous pap\n");
									apap = temppap;
									temppap = NULL;
									}
								}
							}
						else
							{
							/*begin tappap search*/
							/*if we're in a table search for the one with fTtp*/

							if (apap->fInTable)
								{
								k = i;
								do
									{
									if (k==i)
										tapfc1 = fccount;
									else
										tapfc1 = avalrgfc[k];
									error(stderr,"2. we search for the tap here\n");
									error(stderr,"tappap nexts are %x, k is %x\n",tapfc1,k);
									do
										{
										error(stderr,"tappap nexts are %x %x\n",tapfc1,avalrgfc[k+1]);
										tapfc2 = tapfc1;
										tappap = get_complex_pap(tapfc1,plcfbtePapx,k,nopieces,intervals,rgfc,main,avalrgfc,&tapfc1,NULL,&paraendpiece,sheet,a_list_info);
										}
									while( (!tappap->fTtp) && (tappap != NULL) && (tapfc1 != tapfc2)) ;
									k++;
									}
								while ( (!tappap->fTtp) && (tappap != NULL) && (k<nopieces) );
								/*
								at this stage tappap has the correct row structure stored in it
								that we want apap to have
								*/
								apap->ourtap = tappap->ourtap;
								error(stderr,"finished 2nd search for the tap here\n");
								error(stderr,"no of cells is %d, %d\n",apap->ourtap.cell_no,tappap->ourtap.cell_no);
								}
							/*end tappap search*/

							/*remove unneeded pap*/
							if (temppap != NULL)
								free(temppap);
							temppap = NULL;
							}

						}


					if ((fccount == chpnextfc)  || (fccount >= lastfc))
						{
						lastchpfc=1;
						achp = get_complex_chp(fccount,plcfbteChpx,i,nopieces,chpintervals,rgfc,main,avalrgfc,&chpnextfc,sheet,apap->istd);
						error(stderr," CHP: the next para is at (%x)\n",chpnextfc);

						if (achp == NULL)
							error(stderr,"we failed in out attempt to get a chp\n");
						else
							{
							if (headerfooterflag == 1)
								achp->color="#7f5555";
							else if (headerfooterflag == 2)
								achp->color="#330099";
							error(stderr,"before gprl chp fontcode is %d\n",achp->fontcode);
							decode_gpprls(apap,achp,sprm,paraendpiece,&asprmlist,sheet);
							error(stderr,"after gprl chp fontcode is %d\n",achp->fontcode);
							decode_e_list(apap,achp,a_list_info);
							decode_e_chp(achp);
							error(stderr,"after decode chp fontcode is %d\n",achp->fontcode);
							}
						}

					if (fccount >= lastfc) 
						{
						decode_gpprls(apap,achp,sprm,paraendpiece,&asprmlist,sheet);
						decode_e_specials(apap,achp,a_list_info);
						decode_e_table(apap,achp,a_list_info);
						decode_s_table(apap,achp,a_list_info);
						decode_s_specials(apap,achp,a_list_info);
						lastfc=-1;
						}

					if (lastchpfc) 
						{
						lastchpfc=-1;
						decode_s_chp(achp);
						if ( (letter != 12) && (letter != 13) )
							{
							decode_s_list(apap,achp,a_list_info,fontnamelist);
							error(stderr,"list started following letter is %d\n",letter);
							}
						}


					if (cp >= begincp)
						{
						if (headerfooterflag)
							{
							if (letter == 13)
								{
								/*
								headers and footers seem to continue until 2 0x0d are reached, they dont
								appear after all to go until the len derived from the header table
								like i thought originally.
								*/
								d_count++;
								if (d_count == 2)
									{
									notfinished=0;
									break;
									}
								}
							else
								d_count=0;
							}
						
						error(stderr,"decoding letter: fc is %x, nextfc is %x\n",fccount,nextfc);
						if (hack)
							newpage = decode_letter(letter,1,apap,achp,all_fields[0],main,fontnamelist,a_list_info,portions);
						else
							newpage = decode_letter(letter,1,apap,achp,all_fields[0],main,fontnamelist,a_list_info,portions);
						error(stderr,"W:sync, actuallt at %x, fccount is %x and aval is %xthough\n",ftell(main),fccount,fccount);
						}
					else
						cp++;

					/*if newpage then decode header*/
					if (newpage)
						{
						error(stderr,"clx footer\n");
						decode_clx_footer(rgfc,nopieces,startpiece,begincp,endcp,in,main,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,headerfooterflag);
						}

					if (cp >= endcp)
						{
						error(stderr,"reached end of header or main\n");
						if (!headerfooterflag)
							{
							notfinished=0;
							break;
							}
						/*else well trust to the doubling of 0x0d to determine the end of the footer/header*/
						}

					j++;
					}/*end for/while j*/
					
				error(stderr,"here after header ?\n");

				if (achp != NULL)
					{
					free(achp);
					achp = NULL;
					}
				}
			}
		else
			fprintf(stderr,"some kind of error occured, byte count off\n");
		}


	if (apap == NULL)
		{
		apap = (pap *)malloc(sizeof(pap));
		if (apap == NULL)
			return;
		}
	
	apap->istd = 0;
	apap->ilvl=-1;
	apap->tableflag=0;
	decode_e_list(apap,achp,a_list_info);
	decode_e_specials(apap,achp,a_list_info);
	decode_e_table(apap,achp,a_list_info);
	if (apap !=NULL)
		free(apap);
	if (achp !=NULL)
		free(achp);

	if (!newpage)
		{
		error(stderr,"clx footer 2\n");
		decode_clx_footer(rgfc,nopieces,startpiece,begincp,endcp,in,main,fcClx,lcbClx,intervals,chpintervals,plcfbtePapx,plcfbteChpx,all_fields,a_list_info,sheet,portions,fontnamelist,headerfooterflag);
		}

	if (rgfc != NULL)
		free(rgfc);
	if (avalrgfc != NULL)
		free(avalrgfc);
	if (sprm != NULL)
		free(sprm);

	fseek(in,pos,SEEK_SET);
	fseek(main,mainpos,SEEK_SET);
	}


chp *get_chp(U32 pageindex,FILE *in, U32 charindex, U32 *nextfc,style *sheet,U16 istd)
	{
	long pos = ftell(in);
	U8 i;
	U16 l;
	U16 offset;

	U8 cb;
	U16 clist=0;

	chp *retchp;

	error(stderr,"\nlooking for CHP in page %d given istd %d\n",pageindex,istd);
	/*this no refers to 512*pageindex ?*/
	error(stderr,"\n%x\n",(512*pageindex));


	*nextfc = find_next_smallest_fc(charindex,pageindex,in,&i,NULL);
	error(stderr,"next char lim is %d (%x)\n",*nextfc,*nextfc);

	retchp = (chp *) malloc(sizeof(chp));
	
	if (retchp == NULL)
		{
		fprintf(stderr,"no mem available\n");
		exit(-1);
		}

	error(stderr,"the istd of this chp is %d\n",istd);
	retchp->fBold=sheet[istd].thechp.fBold;
	error(stderr,"based on bold is %d\n",retchp->fBold);
	retchp->fItalic=sheet[istd].thechp.fItalic;
	error(stderr,"based on italic is %d\n",retchp->fItalic);
	retchp->ascii_font=sheet[istd].thechp.ascii_font;
	retchp->eastfont=sheet[istd].thechp.eastfont;
	retchp->noneastfont=sheet[istd].thechp.noneastfont;
	retchp->fontsize=sheet[istd].thechp.fontsize;
	error(stderr,"font set to styles size %d\n",sheet[istd].thechp.fontsize);
	retchp->supersubscript=sheet[istd].thechp.supersubscript;
	retchp->fontcode=sheet[istd].thechp.fontcode;
	retchp->fontspec=sheet[istd].thechp.fontspec;
	retchp->color=sheet[istd].thechp.color;
	retchp->underline=sheet[istd].thechp.underline;

	/*leap ahead to the BX we want*/
	fseek(in,i,SEEK_CUR);

	/*the first byte is the one we want*/
	offset = getc(in);
	error(stderr,"CHP: chpx offset is %ld %x, going to %x\n",offset,offset,(512*(pageindex))+offset*2);
	if (offset == 0)
		{
		error(stderr,"CHP: special chpx offset leaving now\n");
		fseek(in,pos,SEEK_SET);
		error(stderr,"at this end bold is %d\n",retchp->fBold);
		return(retchp);
		}
	
	/*this section is fucked up, why does it appear that i have to use twice
	the offset i get out of this value ?*/
	fseek(in,(512*(pageindex))+offset*2,SEEK_SET);
	cb = getc(in);
	error(stderr,"CHP: cb was %d\n",cb);


	if (cb != 0)
		{
		l=0;
		while(l<cb)
			{
			clist = read_16ubit(in);
			l+=2;
			error(stderr,"decoding sprm %X\n",clist);
			decode_sprm(in,clist,NULL,retchp,&l,NULL,sheet,istd);
			}
		}

	fseek(in,pos,SEEK_SET);
	error(stderr,"at end bold is %d\n",retchp->fBold);
	return(retchp);
	}
		
void decode_ilfo(pap *retpap,list_info *a_list_info)
	{
	int j;
	
	/*
	else now we use our a_list_data to generate the paps list_data
	including the text to use, whether to prepend a index or not
	what format the index is in, and the start index
	*/
	/*
	first get the text, ) / . / string / whatever
	*/
	error(stderr,"ilfo string follows %d\n",retpap->ilfo);
	if (retpap->ilfo >= a_list_info->nooflfos)
		{
		if (retpap->ilfo != 2047)
			error(stderr,"hmm problem\n");
		else
			error(stderr,"legacy anld\n");
		return;
		}
	error(stderr,"ilfo request is %d, the id in the lfo is %x\n",retpap->ilfo,a_list_info->lst_ids[retpap->ilfo]);

	/*
	what should happen here, is after we get this base list data, 
	we add the overrides to a copy of our own
	*/

	retpap->list_data = &(a_list_info->o_list_def[retpap->ilfo]);
	
	retpap->list_data->id = a_list_info->lst_ids[retpap->ilfo];
	for (j=0;j<retpap->list_data->len;j++)
	            error(stderr,"--> %c",retpap->list_data->list_string[j]);
	}


pap *get_pap(U32 pageindex,FILE *in, U32 charindex, U32 *nextfc, style *sheet,list_info *a_list_info)
	{
	long pos = ftell(in);
	U8 i,k;
	U8 BX[13];
	U16 offset;
	U16 len;

	U8 cw;
	U32 clist;

	pap *retpap;

	error(stderr,"\nlooking for PAP in page %d\n",pageindex);
	/*this no refers to 512*pageindex ?*/
	error(stderr,"\n%x\n",(512*pageindex));


	*nextfc = find_next_smallest_fc(charindex,pageindex,in,&i,NULL);

	retpap = (pap *) malloc(sizeof(pap));
	
	if (retpap == NULL)
		{
		fprintf(stderr,"no mem available\n");
		exit(-1);
		}

	/*leap ahead to the BX we want*/
	fseek(in,i*13,SEEK_CUR);

	/*pull out BX word offset*/
	for(k=0;k<13;k++)
		BX[k] = getc(in);
	/*the first byte is the one we want*/
	offset = BX[0];
	error(stderr,"papx offset is %ld %x, going to %x\n",offset,offset,(512*(pageindex))+offset*2);
	if (BX[0] == 0)
		error(stderr,"special papx offset ?\n");
	/*this section is fucked up, why does it appear that i have to use twice
	the offset i get out of this value ?*/
	fseek(in,(512*(pageindex))+offset*2,SEEK_SET);
	cw = getc(in);
	if (cw == 0)
		{
		error(stderr,"cw was pad %d\n",cw);
		cw = getc(in);
		error(stderr,"cw was %d\n",cw);
		cw=cw*2;
		error(stderr,"so bytes are %d\n",cw);
		}
	else
		cw=cw*2; /*when the pap is in a stsh then this is not done*/
		
	error(stderr,"cw bytes are %d\n",cw);

	len=0;
	retpap->fInTable = 0;
	retpap->fTtp= 0;
	retpap->ilvl = -1;
	retpap->ilfo = -1; /*index into hpllfo*/
	retpap->list_data=NULL;
	retpap->tableflag=0;
	retpap->istd = read_16ubit(in);
	len+=2;
	error(stderr,"istd index is %d\n",retpap->istd);
	/*
	take the istd and get the style from the decoded style list
	and shove in the starting values values from that
	*/
	retpap->fInTable  = sheet[retpap->istd].thepap.fInTable;
	retpap->fTtp = sheet[retpap->istd].thepap.fTtp;
	retpap->ilvl = sheet[retpap->istd].thepap.ilvl;
	retpap->ilfo = sheet[retpap->istd].thepap.ilfo;
	retpap->list_data = sheet[retpap->istd].thepap.list_data;
	retpap->ouranld = sheet[retpap->istd].thepap.ouranld;

	error(stderr,"BEGIN");
	while (len < cw)
		{
		clist = read_16ubit(in);
		len+=2;
		/*
		and *why* do i have to take this byte out to get what i want ?
		*/
		error(stderr,"clist %x \n",clist);
		decode_sprm(in,clist,retpap,NULL,&len,NULL,sheet,retpap->istd);
		}

	error(stderr,"END");

	fseek(in,pos,SEEK_SET);
	return(retpap);
	}

int find_FKPno_papx(U32 fc,U32 *plcfbtePapx,U32 intervals)
	{
	int j=1;
	while (j<intervals+1)
		{
		error(stderr,"->page %d, fc is (%x) and plcfbtePapx[j] is %x\n",j,fc,plcfbtePapx[j]);
		if (fc < plcfbtePapx[j])
			{
			error(stderr,"it was less that it\n");
			error(stderr,"so the FKP thatll have the limits of this is %d\n",plcfbtePapx[j+intervals]);
			return(plcfbtePapx[j+intervals]);
			break;
			}
		j++;
		}
	error(stderr,"no FKP pap found\n");
	return(-1);
	}

int find_FKPno_chpx(U32 fc,U32 *plcfbteChpx,U32 chpintervals)
	{
	int j=1;
	while (j<chpintervals+1)
		{
		error(stderr,"->chp page %d, fc is (%x) and plcfbteChpx[j] is %x\n",j,fc,plcfbteChpx[j]);
		if (fc < plcfbteChpx[j])
			{
			error(stderr,"CHP: it was less that it\n");
			error(stderr,"CHP: so the FKP thatll have the limits of this is %d\n",plcfbteChpx[j+chpintervals]);
			return(plcfbteChpx[j+chpintervals]);
			break;
			}
		j++;
		}
	error(stderr,"CHP: no chp found\n");
	return(-1);
	}

U32 find_next_smallest_fc(U32 charindex,U32 pageindex, FILE *in, U8 *location,long *pos)
	{
	U8 crun,i;
	U32 *rgfc;
	U32 rval=-1;
	if (pos != NULL)
		*pos = ftell(in);

	if (pageindex != -1)
		{
		fseek(in,(512*pageindex)+511,SEEK_SET);
		crun = getc(in);
		error(stderr,"there are %d paragraphs/char runs in this zone at ",crun);
		rgfc = (U32 *) malloc(sizeof(U32)*crun+1);
		if (rgfc== NULL)
			{
			fprintf(stderr,"no memory argh\n");
			exit(-1);
			}
		fseek(in,(512*pageindex),SEEK_SET);
		for(i=0;i<crun+1;i++)
			{
			rgfc[i] = read_32ubit(in);
			error(stderr,"(%X) ", rgfc[i]);
			}
		error(stderr,"\n");
		i=0;
		while (i<crun)
			{
			if (charindex <  rgfc[i+1])
				{
				error(stderr,"looking for BX %ld, charindex is %ld (%x),  rgfc is %ld (%x),\n",i,charindex,charindex, rgfc[i+1],rgfc[i+1]);
				*location = i;
				rval = rgfc[i+1];
				break;
				}
			i++;		
			}

		free(rgfc);
		}
	if (pos != NULL)
		{
		fseek(in,*pos,SEEK_SET);
		error(stderr,"papx: reset stream\n");
		}
	return(rval); 
	}


chp * get_complex_chp(U32 fc,U32 *plcfbteChpx,U8 i,U8 nopieces,U32 chpintervals,U32 *rgfc,FILE *main,U32 *avalrgfc,U32 *thenextone,style *sheet,U16 istd)
	{
	chp *achp=NULL;
	int tempfck;
	U8 location;
	long passposition;
	U32 nextfc=0;
	U32 tempfc;

	/*we have the chp's fc*/

	/*
	Using the FC, search the FCs FKP for the largest FC less 
	than the character's FC
	*/

	/*finding the correct FKP for this fc*/
	/*
	The CHPX FKP stored in that page is fetched and then the rgfc in the 
	FKP is searched to locate the bounds of the run of
	exception text that encompasses the character.
	*/
	tempfck = find_FKPno_chpx(fc,plcfbteChpx,chpintervals);

	/*now attempt to find the end of the run of text*/
	if (tempfck != -1)
		{
		nextfc = find_next_smallest_fc(fc,tempfck,main,&location,&passposition);
		error(stderr,"CHP: in this FKP the next fc larger than (%x) is (%x)\n",fc,nextfc);
		error(stderr,"CHP: the end of this piece is (%x)\n",avalrgfc[i]+rgfc[i+1]-rgfc[i]);
		}

	/*
	The CHPX for that run is then located within the FKP,
	and the CHPX is applied to the contents of the local CHP
	*/
	achp = get_chp(tempfck,main,nextfc-1,&tempfc,sheet,istd);
	*thenextone = nextfc;
	return(achp);
	}


pap * get_complex_pap(U32 fc,U32 *plcfbtePapx,U8 i,U8 nopieces,U32 intervals,U32 *rgfc,FILE *main,U32 *avalrgfc,U32 *thenextone,U32 *theotherone,int *paraendpiece,style *sheet,list_info *a_list_info)
	{
	pap *apap=NULL;
	int tempfck;
	U8 location,j;
	long passposition;
	U32 fc2;
	U32 nextfc=0;
	U32 tempfc;
	

	*paraendpiece = i;

	error(stderr,"Searching for PAP\n");
	/*
	if we are not at the beginning of a paragraph get the 
	bounds of this paragraph, using the end mark of the paragraph
	look for the char after it, and then look at fkp.rgbx[i - 1] 
	to get the PAPX (last non-fastsaved one), add the SPRMS 
	that would be got
	from the clxt == 1 stuff
	*/

	/*
	Using the FC, search the FCs FKP for the smalled FC greater
	than the character's FC
	*/

	/*finding the correct FKP for this fc*/
	tempfck = find_FKPno_papx(fc,plcfbtePapx,intervals);

	/*now attempt to find the end of the paragraph*/
	if (tempfck != -1)
		{
		nextfc = find_next_smallest_fc(fc,tempfck,main,&location,&passposition);
		error(stderr,"in this FKP the next fc larger than (%x) is (%x)\n",fc,nextfc);
		error(stderr,"the end of this piece is (%x)\n",avalrgfc[i+1]);
		/*
		error(stderr,"the end of this piece is (%x)\n",avalrgfc[i]+rgfc[i+1]-rgfc[i]);
		*/
		}
	else
		{
		/*set it to original again*/
		nextfc = *thenextone;
		/*
		nextfc = (avalrgfc[i]+rgfc[i+1]-rgfc[i]) +1;
		*/
		error(stderr,"dodgy nextfc\n");
		}

	if (theotherone != NULL)
		{
		error(stderr,"setting theotherone to %x\n",nextfc);
		*theotherone = nextfc;
		}

	/*
	if ( nextfc <= (avalrgfc[i]+rgfc[i+1]-rgfc[i]) )
	*/

	fc2 = avalrgfc[i+1];
    if (fc2 & 0x40000000UL)
		{
        fc2 = fc2 & 0xbfffffffUL;
        fc2 = fc2/2;
        }
	error(stderr,"fc2 is %x\n",fc2);

	/**thenextone = nextfc;*/

	if ( nextfc <= (fc2) )
		{
		error(stderr,"not doing para end search\n");
		error(stderr,"the end of the paragraph that describes this piece is at (%x)",nextfc-1);
		/*this means that if we grab the PAP of this char that we have got the pap for the piece*/
		*paraendpiece = i;
		if (tempfck != -1)
			apap = get_pap(tempfck,main,nextfc-1,&tempfc,sheet,a_list_info);
		/*in this case the paragraph ends on nextfc*/
		*thenextone=nextfc;
		}
	else if(nextfc == -1)
		{
		nextfc = fc;
		error(stderr,"BUGGING OUT\n");
		}
	else
		{
		error(stderr,"PAP: doing para end search\n");
		/*
		in this case the paragraph will have to be looked for again
		when this piece comes to an end ?
		*/
		*thenextone = fc2;

		/*
		we go through the pieces looking for one that has a 
		end of paragraph mark in it
		
		It's possible to check if a piece contains a paragraph
		mark by using the FC of the beginning of the piece to 
		search in the FKPs for the smallest FC in the FKP
		rgfc that is greater than the FC of the beginning of the piece
		*/
		for (j=i+1;j < nopieces;j++)
			{
			fc = avalrgfc[j];
			if (fc & 0x40000000UL)
					{
					fc = fc & 0xbfffffffUL;
					fc = fc/2;
					}
			error(stderr,"fc pulled out here is %d (%x)\n",fc,fc);
			tempfck = find_FKPno_papx(fc,plcfbtePapx,intervals);
			if (tempfck != -1)
				{
				nextfc = find_next_smallest_fc(fc,tempfck,main,&location,&passposition);
				error(stderr,"the next one is (%x)\n",nextfc);
				error(stderr,"less than aval is (%x),and end is (%x)",fc,fc+rgfc[j+1]-rgfc[j]);
				error(stderr,"avals are %x and %x\n",nextfc-1,fc+rgfc[j+1]-rgfc[j]);
			/*
				if ((nextfc <= (fc+rgfc[j+1]-rgfc[j])) || ((nextfc-1 >= fc+rgfc[j+1]-rgfc[j]) && (j==i+1)))
			*/
			/*
				if ((nextfc <= (fc+rgfc[j+1]-rgfc[j])) || ((nextfc-1 == fc+rgfc[j+1]-rgfc[j]) && (j==i+1)))
			*/
			/*
				if (nextfc <= (fc+rgfc[j+1]-rgfc[j])) 
			*/
				fc2 = avalrgfc[j+1];
				if (fc2 & 0x40000000UL)
					{
					fc2 = fc2 & 0xbfffffffUL;
					fc2 = fc2/2;
					}
				error(stderr,"fc2 is %x\n",fc2);

				if (nextfc <= fc2 )
					{
					/*well this is the end then*/
					error(stderr,"the end of the paragraph that describes this piece is at (%x), after trying further",nextfc-1);
					*paraendpiece = j;

					error(stderr,"the pieceend is %d\n",*paraendpiece);
					if (tempfck != -1)
						apap = get_pap(tempfck,main,nextfc-1,&tempfc,sheet,a_list_info);
					break;
					}
				}
			}
		}	

	/*	
	*thenextone = nextfc;
	*/
		
	if (apap != NULL)
		error(stderr,"PAP: istd is %ld\n",apap->istd);
	return(apap);
	}

void decode_list_nfc(int *value,int no_type)
	{
	char roman[81];
	switch(no_type)
		{
		case 0:
			printf("%d",(*value)++);
			break;
		case 1:	
			printf("%s",decimalToRoman((*value)++,roman));
			break;
		case 2:	
			printf("%s",ms_strlower(decimalToRoman((*value)++,roman)));
			break;
		case 3:
			printf("%c",64+(*value)++); /*uppercase letter*/
			break;
		case 4:
			printf("%c",96+(*value)++); /*lowercase letter*/
			break;
		default:
			break;
		}
	}

void decode_list_level(pap *apap,int inalist)
	{
	int i;
	if (apap->ilvl+1 != 1)
		{
		if (apap->ilvl+1 == inalist)
			{
			printf("\n</BLOCKQUOTE>\n");
			printf("\n<BLOCKQUOTE>\n");
			}
		else
			for(i=inalist;i<apap->ilvl+1;i++)
				printf("\n<BLOCKQUOTE>\n");
		}
	}

void decode_s_anld(pap *apap,chp *achp,list_info *a_list_info,ffn *fontnamelist)
	{
	
	
	int i;
	
	
	chp anldchp;

	error(stderr,"ilvl is %d\n",apap->ilvl);


	if ( ( (apap->ilvl+1) > inalist)  /*|| (tempid)*/ )
		{
		error(stderr,"ANLD: new one is %d",apap->ilvl+1);
		decode_list_level(apap,0);

		/*if we are at a sub level i.e > 0, then */
		error(stderr,"the ilfo to use is %d\n",apap->ilfo);

		inalist=apap->ilvl+1;
		}
		/*
	else
		list_data = apap->list_data;
		*/

	if ( (apap->ilvl) != -1)
		{
		if ( (apap->ilfo > -1) && (newline))
			{
			printf("\n");

			anldchp = *achp;
			if (apap->ouranld.flags1&0x10)
				if (apap->ouranld.flags2&0x08)
					anldchp.fBold =1;
			if (apap->ouranld.flags1&0x20)
				if (apap->ouranld.flags2&0x10)
					anldchp.fItalic=1;
			if (apap->ouranld.flags2&0x02)
					anldchp.underline = apap->ouranld.flags3&0x07;
			anldchp.ascii_font = apap->ouranld.ftc;
			anldchp.eastfont = apap->ouranld.ftc;
			anldchp.noneastfont =apap->ouranld.ftc;
			anldchp.fontsize = apap->ouranld.hps;

			i=0;
			while(i<apap->ouranld.cxchTextBefore)
				{
				error(stderr,"list string-->%d %c\n",apap->ouranld.rgxch[i],apap->ouranld.rgxch[i]);
				if (apap->ouranld.rgxch[i] == '*')
					printf("<img src=\"%s/%d.gif\">",symbolfontdir(),151);
				else
					{
					decode_letter(apap->ouranld.rgxch[i],0,apap,&anldchp,NULL,NULL,fontnamelist,NULL,NULL);
					cp--;
					}
				i++;
				}

			error(stderr,"numbering type is %d\n",apap->ouranld.nfc);
			decode_list_nfc(&(listvalue[apap->ilvl]),apap->ouranld.nfc);

			i=apap->ouranld.cxchTextBefore;
			while(i<apap->ouranld.cxchTextAfter)
				{
				error(stderr,"list string-->%d %c\n",apap->ouranld.rgxch[i],apap->ouranld.rgxch[i]);
				if (apap->ouranld.rgxch[i] == '*')
					printf("<img src=\"%s/%d.gif\">",symbolfontdir(),151);
				else
					{
					decode_letter(apap->ouranld.rgxch[i],0,apap,NULL,NULL,NULL,fontnamelist,NULL,NULL);
					cp--;
					}
				i++;
				}

			printf(" ");
			newline=0;
			}
		}
	}

void decode_s_list(pap *apap,chp *achp,list_info *a_list_info,ffn *fontnamelist)
	{
	
	U32 tempid=0;
	int i;
	
	list_def *list_data=NULL;

	error(stderr,"doing start list\n");

	if (apap->ilfo == 2047)
		{
		error(stderr,"special ilfo, doing an anld\n");
		decode_s_anld(apap,achp,a_list_info,fontnamelist);
		return;
		}
	
	if (apap->ilfo > -1) 
		decode_ilfo(apap,a_list_info);

	if ((apap->list_data != NULL) && (apap->ilvl+1))
		{
		if (lastlistid != apap->list_data->id)
			tempid = 1;
		}


	if ( ( (apap->ilvl+1) > inalist)  || (tempid) )
		{
		error(stderr,"ILVL: incoming indent level %d new one is %d",inalist,apap->ilvl+1);
		decode_list_level(apap,inalist);
#if 0
		if (apap->ilvl+1 != 1)
			{
			if (apap->ilvl+1 == inalist)
				{
				printf("\n</BLOCKQUOTE>\n");
				printf("\n<BLOCKQUOTE>\n");
				}
			else
				for(i=inalist;i<apap->ilvl+1;i++)
					printf("\n<BLOCKQUOTE>\n");
			}
#endif
			

		/*if we are at a sub level i.e > 0, then */
		error(stderr,"the ilfo to use is %d\n",apap->ilfo);

		list_data = apap->list_data;
		
		i=0;
		while ( (i<apap->ilvl) && (list_data->sub_def_list != NULL) )
			{
			error(stderr,"indenting into structure\n");
			list_data = list_data->sub_def_list;
			i++;
			tempid=1;
			}

		if (tempid)
			{
			/*new list, start again*/
			listvalue[apap->ilvl]=list_data->begin_no;
			lastlistid = apap->list_data->id;
			}
		inalist=apap->ilvl+1;
		}
	else
		list_data = apap->list_data;

	if ( (apap->ilvl) != -1)
		{
		if ( (apap->ilfo > -1) && (newline))
			{
			if (list_data != NULL)
				{
				i=0;
				list_data = apap->list_data;
				while ( (i<apap->ilvl)  && (list_data->sub_def_list != NULL) )
					{
					error(stderr,"indenting into structure\n");
					list_data = list_data->sub_def_list;
					i++;
					}

				if (list_data->len > 0)
					{
					i=0;

					flushbreaks();
					printf("\n");

					error(stderr,"list is %x\n",list_data->id);
					while ( (list_data->list_string[i] > 9) && (i<list_data->len) )
						{
						error(stderr,"list string-->%d %c\n",list_data->list_string[i],list_data->list_string[i]);
						if (list_data->list_string[i] == '*')
							printf("<img src=\"%s/%d.gif\">",symbolfontdir(),151);
						else
							{
							decode_letter(list_data->list_string[i],0,apap,&(list_data->achp),NULL,NULL,fontnamelist,NULL,NULL);
							cp--;
							}
						i++;
						}

					if (i < list_data->len)
						{
						
						if (list_data->list_string[i] <= 9)
							{
							error(stderr,"numbering type is %d\n",list_data->no_type);
							decode_list_nfc(&(listvalue[apap->ilvl]),list_data->no_type);
							i++;
							}

						while ( (list_data->list_string[i] > 9) && (i<list_data->len) )
							{
							if (list_data->list_string[i] == '*')
								printf("<img src=\"%s/%d.gif\">",symbolfontdir(),151);
							else
								{
								decode_letter(list_data->list_string[i],0,apap,&(list_data->achp),NULL,NULL,fontnamelist,NULL,NULL);
								cp--;
								}
							i++;
							}
						}
					printf(" ");
					newline=0;
					}
				}
			}
		}
	}

char *ms_strlower(char *in)
	{
	char *useme = in;
	while(*useme != '\0')
		{
		*useme = tolower(*useme);
		useme++;
		}
	return(in);
	}

void decode_s_table(pap *apap,chp *achp,list_info *a_list_info)
	{
	int redotable=0,i;
	float width;
	int clearedspecials=0;
	pap reset;

    reset.istd =0;
    reset.fInTable=0;
    reset.fTtp=0;
	reset.tableflag=0;
	reset.ilvl=-1;
	reset.ilfo=-1;
	reset.list_data=NULL;

	error(stderr,"decoding start specials istd is %d\n",apap->istd);

	if ((!(inatable)) && (apap->fInTable))
		{
		if (!clearedspecials)
			{
			/*decode_e_specials(&reset,achp,a_list_info);*/
			clearedspecials=1;
			}
		flushbreaks();
		printf("\n<table border=1 width=\"100%\">\n");
		error(stderr,"set table\n");
		/*search for tap*/
		inatable=1;
		inarow=0;
		inacell=0;
		lastrowlen=apap->ourtap.cell_no;
		error(stderr,"lastrowlen is %d\n",lastrowlen);
		for (i=0;i<apap->ourtap.cell_no+1;i++)
			{
			lastcellwidth[i] = apap->ourtap.cellwidth[i];
			error(stderr,"dx-->%d",lastcellwidth[i]);
			}
		}

	if ( ((inatable) && (apap->fInTable) && (!apap->fTtp)) || ((inatable) && (!inacell) && (inarow)) )
		{
		if (inarow == 0)
			{
			if (lastrowlen != apap->ourtap.cell_no)
				{
				error(stderr,"well have to start a new table\n");
				redotable=1;
				}
			else 
				{
				for (i=0;i<apap->ourtap.cell_no+1;i++)
					{
					if (lastcellwidth[i] != apap->ourtap.cellwidth[i])
						redotable=1;
					}
				}

			if (redotable)
				{
				if (!clearedspecials)
					{
					/*decode_e_specials(&reset,achp,a_list_info);*/
					clearedspecials=1;
					}
				flushbreaks();
				printf("\n</table>\n");
				printf("\n<table border=1 width=\"100%\">\n");
				error(stderr,"redone table\n");
				inatable=1;
				inarow=1;
				inacell=0;
				lastrowlen=apap->ourtap.cell_no;
				for (i=0;i<apap->ourtap.cell_no+1;i++)
					lastcellwidth[i] = apap->ourtap.cellwidth[i];

				}

			if (!clearedspecials)
				{
				/*decode_e_specials(&reset,achp,a_list_info);*/
				clearedspecials=1;
				}
			printf("\n<tr>\n");
			rowcount=0;
			inarow = 1;
			}
			
		if ( (inacell == 0) && (rowcount < apap->ourtap.cell_no) )
			{
			width = (apap->ourtap.cellwidth[rowcount+1]-apap->ourtap.cellwidth[rowcount])*100;
			width = rint(width/apap->ourtap.tablewidth);
			printf("\n<td valign=\"top\" width=\"%.0f%%\" >\n",width); 
			inacell=1;
			rowcount++;
			}
		/*weve come into another cell*/
		}
	}

void decode_s_specials(pap *apap,chp *achp,list_info *a_list_info)
	{
	int redotable=0,i;
	int resetchp=0;
	float width;
	chp reset;

	reset.fBold=0;
	reset.fItalic=0;
	reset.underline=0;
	reset.ascii_font=0;
	reset.eastfont=0;
	reset.noneastfont=0;
	reset.fontsize=NORMAL;
	reset.color = 0;


	error(stderr,"decoding start specials istd is %d\n",apap->istd);

	if (ignoreheadings == 0)
		{
		if ((apap->istd == 1) && (inah1 != 1))
			{
			inah1=1;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H1>");
			}

		if ((apap->istd == 2) && (inah1 != 2))
			{
			inah1=2;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H2>");
			}

		if ((apap->istd == 3) && (inah1 != 3))
			{
			inah1=3;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H3>");
			}

		if ((apap->istd == 4) && (inah1 != 4))
			{
			inah1=4;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H4>");
			}

		if ((apap->istd == 5) && (inah1 != 5))
			{
			inah1=5;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H5>");
			}

		if ((apap->istd == 6) && (inah1 != 6))
			{
			inah1=6;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H6>");
			}

		if ((apap->istd == 7) && (inah1 != 7))
			{
			inah1=7;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H7>");
			}

		if ((apap->istd == 8) && (inah1 != 8))
			{
			inah1=8;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H8>");
			}

		if ((apap->istd == 9) && (inah1 != 9))
			{
			inah1=9;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("<H9>");
			}
		}	

	error(stderr,"manually doing start chp\n");
	}

void decode_e_list(pap *apap,chp *achp,list_info *a_list_info)
	{
	int i;
	int lvl;
	error(stderr,"inah1 is going in %d\n",inah1);
	if ( (apap->ilvl+1) < inalist)
		{
		error(stderr,"ILVL: apap->ilvl+1 id %d inalist is %d\n",(apap->ilvl+1),inalist);

		if (apap->ilvl+1 == 0)
			lvl = 1;
		else
			lvl = apap->ilvl+1;

		for(i=inalist;i>lvl;i--)
			printf("\n</BLOCKQUOTE>");
		inalist=apap->ilvl+1;
		}
	}

void decode_e_table(pap *apap,chp *achp,list_info *a_list_info)
	{
	pap reset;
	chp resetc;
	int clearedspecials=0;
	error(stderr,"decoding end table\n");

    reset.istd =0;
    reset.fInTable=0;
    reset.fTtp=0;
	reset.tableflag=0;
	reset.ilvl=-1;
	reset.ilfo=-1;
	reset.list_data=NULL;

	resetc.fBold=0;
	resetc.fItalic=0;
	resetc.underline=0;
	resetc.ascii_font=0;
	resetc.eastfont=0;
	resetc.noneastfont=0;
	resetc.fontsize=NORMAL;
	resetc.color = 0;

	if ((apap->fInTable == 1) && (apap->fTtp == 1) && apap->tableflag)
		{
		error(stderr,"cell and row end\n");
		if (!clearedspecials)
			{
			decode_e_chp(&resetc);
			decode_e_specials(&reset,achp,a_list_info);
			clearedspecials=1;
			}
		printf("\n</tr>\n");
#if 0
		printf("\n</table>\n");
		inatable=0;
#endif
		inarow=0;
		inacell=0;
		apap->tableflag=0;
		}
	else if ((apap->fInTable == 1)  && (apap->fTtp != 1) && apap->tableflag )
		{
		if (!clearedspecials)
			{
			decode_e_chp(&resetc);
			decode_e_specials(&reset,achp,a_list_info);
			clearedspecials=1;
			}
		printf("\n</td>\n");
		inacell=0;
		apap->tableflag=0;
		error(stderr,"cell end\n");
		}

	if ( (inatable) && (!apap->fInTable) && (!inarow) )
		{
		error(stderr,"table ends here\n");
		if (!clearedspecials)
			{
			decode_e_chp(&resetc);
			decode_e_specials(&reset,achp,a_list_info);
			clearedspecials=1;
			}
		printf("\n</table>\n");
		lastrowlen=0;
		inatable=0;
		}

	}
void decode_e_specials(pap *apap,chp *achp,list_info *a_list_info)
	{
	int resetchp=0;
	chp reset;
	error(stderr,"decoding specials istd is %d\n",apap->istd);
	/*before a para ends, well reset all chars to original defaults*/

	reset.fBold=0;
	reset.fItalic=0;
	reset.underline=0;
	reset.ascii_font=0;
	reset.eastfont=0;
	reset.noneastfont=0;
	/*
	reset.fontsize=currentfontsize;
	*/
	
	reset.fontsize=NORMAL;
	

	reset.color = 0;
	/*
	if (achp != NULL)
		reset.color = achp->color;
	else
		error(stderr,"no chp here ?\n");
	*/

	error(stderr,"manual end chp\n");
	/*
	decode_e_chp(&reset);
	*/

	if (ignoreheadings ==0)
		{
		if ((apap->istd != 9) && (inah1 == 9))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
				
			printf("</H9>\n");
			}
		else if ((apap->istd != 8) && (inah1 == 8))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H8>\n");
			}
		else if ((apap->istd != 7) && (inah1 == 7))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H7>\n");
			}
		else if ((apap->istd != 6) && (inah1 == 6))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H6>\n");
			}
		else if ((apap->istd != 5) && (inah1 == 5))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H5>\n");
			}
		else if ((apap->istd != 4) && (inah1 == 4))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H4>\n");
			}
		else if ((apap->istd != 3) && (inah1 == 3))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H3>\n");
			}
		else if ((apap->istd != 2) && (inah1 == 2))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H2>\n");
			}
		else if ((apap->istd != 1) && (inah1 == 1))
			{
			inah1=0;
			if (!resetchp)
				{
				decode_e_chp(&reset);
				resetchp=1;
				}
			printf("</H1>\n");
			}
		}
	error(stderr,"inah1 is now %d\n",inah1);
	}

void decode_gpprls(pap *apap,chp *achp,U16 *gpprl,int index,Sprm *sprmlists,style *sheet)
	{
	/**/
	int j=0;
	U16 i=0;
	Sprm *thesprmlist=sprmlists;
	U16 sprm;
	U8 operand;
	U8 *pointer;

	error(stderr,"index were looking for is %d\n",index);
	if (index <0)
		return;

	/*the index were given is the sprm, if its a varient 1 
	ignore it for now, if its varient 2 go through the list of sprms countinf
	varients 2, until we get to this one*/
	if (0 == (gpprl[index] & 0x01))
		{
		error(stderr,"varient 1s, (%x)\n",gpprl[index]);
		/*
		sprm = (gpprl[index] >> 1) && 0x00FF;
		*/
		sprm = (gpprl[index] >> 1) & 0x00FF;
		operand = gpprl[index] >> 8;
		error(stderr,"GPRL is (%x) operand is %d",sprm,operand);
		return;
		}
	else
		{
		error(stderr,"varient 2s, (%x) (%x) (%x)\n",gpprl[index]&0xFFFE,gpprl[index]>>1,gpprl[index]);
		for (i=0;i<index;i++)
			{
			if (gpprl[i] & 0x01)
				j++;
			}
		error(stderr,"read index val is %d\n",j);
		}
	i=0;	
	while(i<(gpprl[index]>>1))
		{
		thesprmlist=thesprmlist->next;
		if (thesprmlist == NULL)
			{
			error(stderr,"gpprl index is wrong at %d!\n",i);
			return;
			}
		i++;
		}


/*hum 261*/
	i=0;
	error(stderr,"sprm list len is %d\n",thesprmlist->len);
	while (i<thesprmlist->len)
		{
		sprm = sread_16ubit(thesprmlist->list+i);
		i+=2;
		error(stderr,"clist is %x, at len point %d\n",sprm,i);

		pointer = thesprmlist->list+i;
		decode_sprm(NULL,sprm,apap,achp,&i,&pointer,sheet,apap->istd);
		}
	}


U16 dread_16ubit(FILE *in,U8 **list)
	{
	U8 *temp;
	U16 ret;
	if (list == NULL)
		return(read_16ubit(in));
	else
		{
		temp = *list;
		(*list)+=2;
		ret = sread_16ubit(temp);
		error(stderr,"dread temp is %X and %X, ->%X\n",*temp,*(temp+1),ret);
		return(ret);
		}
	}

U8 dgetc(FILE *in,U8 **list)
	{
	U8 *temp;
	if (list == NULL)
		return(getc(in));
	else
		{
		temp = *list;
		(*list)++;
		return(sgetc(temp));
		}
	}

void decode_sprm(FILE* in,U16 clist,pap *retpap,chp *retchp,U16 *l,U8 **list,style *sheet,U16 istd)
	{
	int i;
	int sprmlen;
	U16 sprm2;
	U8 len;
	U16 j;
	int orig;
	chp emchp;
	

	

	error(stderr,"SPRM is %x\n",clist);

	switch(clist)
		{
		/*pap*/
		case 0xC63E:
			error(stderr,"anld here\n");
			len = dgetc(in,list);
			(*l)++;
			retpap->ouranld.nfc = dgetc(in,list);
			retpap->ouranld.cxchTextBefore = dgetc(in,list);
			retpap->ouranld.cxchTextAfter= dgetc(in,list);
			retpap->ouranld.flags1=dgetc(in,list);
			retpap->ouranld.flags2=dgetc(in,list);
			retpap->ouranld.flags3=dgetc(in,list);
			retpap->ouranld.ftc=dread_16ubit(in,list);
			retpap->ouranld.hps=dread_16ubit(in,list);
			retpap->ouranld.startat=dread_16ubit(in,list);
			dread_16ubit(in,list);
			dread_16ubit(in,list);
			dread_16ubit(in,list);
			dread_16ubit(in,list);
			for (i=0;i<32;i++)
				retpap->ouranld.rgxch[i] = dread_16ubit(in,list);
			(*l)+=84;
			break;
		case 0x2602:
		case 0x2640:
			error(stderr,"aha lvl!!!\n");
			dgetc(in,list);
			(*l)++;
			break;
		case 0xC615:
		case 0xC60D:
			error(stderr,"TABTABTAB\n");
			len = dgetc(in,list);
			error(stderr,"len is %d\n",len);
			for (i=0;i<len;i++)
				{
				dgetc(in,list);
				(*l)++;
				}
			(*l)++;
			break;
		case 0x2416:
			retpap->fInTable = dgetc(in,list);
			error(stderr,"FIntable set to %d\n",retpap->fInTable);
			(*l)++;
			break;
		case 0x2417:
			retpap->fInTable = 1;
			retpap->fTtp = dgetc(in,list);
			error(stderr,"FIntable set to %d indirectly\n",retpap->fInTable);
			(*l)++;
			break;
		case 0x260A:
			retpap->ilvl = dgetc(in,list);
			error(stderr,"ilvl set to %d\n",retpap->ilvl);
			if (retpap->ilvl > 8)
				{
				error(stderr,"hmm, strange ilvl here, setting to 0\n");
				retpap->ilvl =0;
				}
			else 
				retpap->ilfo=0;
			(*l)++;
			break;
		case 0x460B:
			/*
			retpap->ilfo = (long)(short)dread_16ubit(in,list);
			*/
			retpap->ilfo = dread_16ubit(in,list);
			/*
			like Collin Park (collin@hpycla.kobe.hp.com) says
			i probably have to back through loads of code and 
			check for sign extensions and friends, oh oh
			*/
			error(stderr,"ilfo is %d\n",retpap->ilfo);
			if (retpap->ilfo == 2047)
				error(stderr,"warning, special list depth\n");
			else
				{
				if (retpap->ilfo == 0)
					error(stderr,"not numbered (bulleted ?)\n");
				retpap->ilfo--;
				}
			error(stderr,"ilfo is now %d\n",retpap->ilfo);
			(*l)+=2;
			break;
		case 0x4600:
			retpap->istd = dread_16ubit(in,list);
			error(stderr,"MAGIC: istd is %d\n",retpap->istd);
			(*l)+=2;
			break;

		/*chp*/
		case 0xCA47:
			/*
			take the embedded chp, compare to external chp
			the equal fields are set to the styles ones
			*/
			sprmlen=dgetc(in,list);
			(*l)++;
			error(stderr," the len is %d\n",sprmlen);
			j=0;
			init_chp(&emchp);
			while(j<sprmlen)
				{
				sprm2 = dread_16ubit(in,list);
				j+=2;
				error(stderr,"embedded sprm is %X\n",sprm2);
				decode_sprm(in,sprm2,retpap,&emchp,&j,list,sheet,retpap->istd);
				error(stderr,"em j got set to %d\n",j);
				}
			*l = *l + j;
			if (emchp.fBold == retchp->fBold)
				retchp->fBold = sheet[retpap->istd].thechp.fBold;
			if (emchp.fItalic== retchp->fItalic)
				retchp->fItalic= sheet[retpap->istd].thechp.fItalic;
			if (emchp.fontsize== retchp->fontsize)
				retchp->fontsize= sheet[retpap->istd].thechp.fontsize;
			if (emchp.underline== retchp->underline)
				retchp->underline= sheet[retpap->istd].thechp.underline;

			/*others not implemented yet*/
			break;

		case 0x486D:
		case 0x486E:
			error(stderr,"lid data is %X",dread_16ubit(in,list));
			(*l)+=2;
			break;
		case 0x0835:
			orig = retchp->fBold;
			retchp->fBold= dgetc(in,list);
			(*l)++;
			switch (retchp->fBold)
				{
				case 1:
					retchp->fBold= 1;
					break;
				case 0:
					retchp->fBold= 0;
					break;
				case 128:
					/*in this case bold value is the based upon val*/
					retchp->fBold = orig;
					break;
				case 129:
					error(stderr,"swapping around\n");
					retchp->fBold = abs(orig-1);
					break;
				}
			error(stderr,"BOLD is %d\n",retchp->fBold);
			/*not sure what each 0,127 etc mean yet*/
			error(stderr,"j here is %d\n",*l);
			break;
		case 0x0836:
			orig = retchp->fItalic;
			retchp->fItalic = dgetc(in,list);
			(*l)++;
			error(stderr,"ITALIC is %d\n",retchp->fItalic);
			switch(retchp->fItalic)
				{
				case 1:
					retchp->fItalic = 1;
					break;
				case 0:
					retchp->fItalic = 0;
					break;
				case 128:
					/*set to original*/
					retchp->fItalic = orig;
					break;
				case 129:
					retchp->fItalic = abs(orig-1);
					break;
				}
			break;
		case 0x6424:
		case 0x6425:
		case 0x6426:
		case 0x6427:
		case 0x6428:
		case 0x6429:
			dread_16ubit(in,list);
			dread_16ubit(in,list);
			(*l)+=4;
			break;
		case 0x0800:
		case 0x0838:
		case 0x0839:
		case 0x083A:
		case 0x083B:
		case 0x083C:
		case 0x2407:
		case 0x2431:
			dgetc(in,list);
			(*l)++;
			break;
		case 0x4845:
			/*how much to sub and super*/
			dread_16ubit(in,list);
			(*l)+=2;
			break;
		case 0x4A43:
			retchp->fontsize = dread_16ubit(in,list);
			(*l)+=2;
			error(stderr,"font is %d\n",retchp->fontsize);
			break;
		case 0x4A30:
			error(stderr,"aha wants to set istd to %ld ?\n",dread_16ubit(in,list));
			(*l)+=2;
			break;
		case 0x261B:
			dgetc(in,list);
			(*l)++;
			break;
		case 0x4A4F:
			retchp->ascii_font=dread_16ubit(in,list);
			error(stderr,"font stuff for ascii text is %ld\n",retchp->ascii_font);
			(*l)+=2;
			break;
		case 0x4A50:
			retchp->eastfont=dread_16ubit(in,list);
			error(stderr,"font stuff for east text is %ld\n",retchp->eastfont);
			(*l)+=2;
			break;
		case 0x4A51:
			retchp->noneastfont=dread_16ubit(in,list);
			error(stderr,"font stuff for noneast text is %ld\n",retchp->noneastfont);
			(*l)+=2;
			break;
		case 0x486B:
		case 0x0418:
		case 0xA413:
		case 0xA414:
		case 0x484B:
		case 0x484E:
			error(stderr,"eat\n");
			dread_16ubit(in,list);
			(*l)+=2;
			break;
		case 0x840F:
		case 0x840E:
			dread_16ubit(in,list);
			(*l)+=2;
			break;
		case 0x9602:
		case 0x9407:
		/*
			retpap->fInTable = 1;
		*/
			error(stderr,"FIntables have been set to %d indirectly ?\n",retpap->fInTable);
			dread_16ubit(in,list);
			(*l)+=2;
			break;
		case 0x2403:
		case 0x0868:
		case 0x2A42:
		case 0x2406:
			dgetc(in,list);
			(*l)++;
			break;
		case 0x2A3E:
			retchp->underline = dgetc(in,list);
			error(stderr,"underline set to %d\n",retchp->underline);
			(*l)++;
			break;
		case 0x2A48:
			retchp->supersubscript = dgetc(in,list);
			error(stderr,"sub super is %d\n",retchp->supersubscript);
			(*l)++;
			break;
		case 0xD605:
			/*
			retpap->fInTable = 1;
			*/
			len = dgetc(in,list);
			(*l)++;
			error(stderr,"FIntable set to %d indirectly\n",retpap->fInTable);
			for(i=0;i<len;i++)
				{
				dgetc(in,list);
				(*l)++;
				}
			break;
		case 0xD608:
			/*
			retpap->fInTable = 1;
			*/
			len = dread_16ubit(in,list);
			(*l)+=2;
			error(stderr,"FIntable set to %d indirectly\n",retpap->fInTable);
			retpap->ourtap.cell_no = dgetc(in,list);
			(*l)++;
			error(stderr,"there are %d cells in this row\n",retpap->ourtap.cell_no);
			retpap->ourtap.tablewidth=0;
			for(i=0;i<retpap->ourtap.cell_no+1;i++)
				{
				retpap->ourtap.cellwidth[i] = (S16) dread_16ubit(in,list);
				error(stderr,"a dx is %d\n",retpap->ourtap.cellwidth[i]);
				(*l)+=2;
				}
			retpap->ourtap.tablewidth=retpap->ourtap.cellwidth[retpap->ourtap.cell_no] - retpap->ourtap.cellwidth[0];
			for(i=0;i<len-1-((retpap->ourtap.cell_no+1)*2);i++)
				{
				dgetc(in,list);
				(*l)++;
				}
			break;
		case 0x6A09:
			retchp->fontcode=dread_16ubit(in,list);
			error(stderr,"font code is %d\n", retchp->fontcode);
			retchp->fontspec=dread_16ubit(in,list);
			error(stderr,"char spec is %d\n",retchp->fontspec);
			retchp->fSpec=1;
			(*l)+=4;
			break;
		case 0x0854:
		case 0x0856:
			dgetc(in,list);
			(*l)++;
			break;
		case 0x0855:
			retchp->fSpec=dgetc(in,list);
			error(stderr,"special set to %d\n",retchp->fSpec);
			(*l)++;
			break;
		case 0x2A53:
		case 0x8840:
			/*i think these all are lumped together and take two bytes*/
			dread_16ubit(in,list);
			(*l)+=2;
			break;
		case 0x6A03:
			retchp->fSpec=1;
			dread_16ubit(in,list);
			dread_16ubit(in,list);
			(*l)+=4;
			break;
		case 0x6412:
			dread_16ubit(in,list);
			dread_16ubit(in,list);
			(*l)+=4;
			break;
		default:
			{
			error(stderr,"unsupported %x l is %d",clist,*l);
			clist = (clist & 0xe000);
			error(stderr,"val %d",clist);
			clist = clist >> 13;
			error(stderr,"val %d",clist);
			len=0;
			switch (clist)
				{
				case 0:
				case 1:
					len=1;
					break;
				case 2:
				case 4:
				case 5: 
					len=2;
					break;
				case 7:
					len=3;
					break;
				case 3:
					len=4;
					break;
				case 6:
					len=dgetc(in,list);
					(*l)++;
					break;
				default:
					error(stderr,"shouldnt see this len value!!\n");
					break;
				}
			
			for(i=0;i<len;i++)
				{
				dgetc(in,list);
				(*l)++;
				}
			error(stderr,"l is now %d\n",*l);
			}
		
		}
	}

void fill_pap(style *stylelist,int m,int b)
	{
	stylelist[m].thepap.fInTable = stylelist[b].thepap.fInTable;
	stylelist[m].thepap.fTtp= stylelist[b].thepap.fTtp;
	stylelist[m].thepap.ilvl = stylelist[b].thepap.ilvl;
	stylelist[m].thepap.ilfo = stylelist[b].thepap.ilfo;
	stylelist[m].thepap.list_data=stylelist[b].thepap.list_data;

	stylelist[m].thechp.fBold=stylelist[b].thechp.fBold;
	stylelist[m].thechp.fItalic=stylelist[b].thechp.fItalic;
	stylelist[m].thechp.ascii_font=stylelist[b].thechp.ascii_font;
	stylelist[m].thechp.eastfont=stylelist[b].thechp.eastfont;
	stylelist[m].thechp.noneastfont=stylelist[b].thechp.noneastfont;
	stylelist[m].thechp.fontsize=stylelist[b].thechp.fontsize;
	stylelist[m].thechp.supersubscript= stylelist[b].thechp.supersubscript;
	stylelist[m].thechp.fontcode=stylelist[b].thechp.fontcode;
	stylelist[m].thechp.fontspec=stylelist[b].thechp.fontspec;
	stylelist[m].thechp.color=stylelist[b].thechp.color;
	}

style *decode_stylesheet(FILE *tablefd,U32 stsh,U32 stshlen)
	{
	U16 sprm=0;
	U16 j;
	int i,upxbytes,len,nostyles,m;
	U16 thingy;
	
	U16 cb;
	style *stylelist;
	U16 pos;
	int baseistd;
	int tempistd;

	error(stderr,"the new stsh is (%x), len (%x)\n",stsh,stshlen);

	fseek(tablefd,stsh,SEEK_SET);
	error(stderr,"not really stsh size is %ld\n",read_16ubit(tablefd));
	
	nostyles = read_16ubit(tablefd);
	error(stderr,"count of styles is %d\n",nostyles);
	error(stderr,"cbSTDBaseInFile is %ld\n",read_16ubit(tablefd));
	for (i=0;i<7;i++)
		read_16ubit(tablefd);

	stylelist = (style *) malloc(sizeof(style) * nostyles);
	if (stylelist == NULL)
		{
		fprintf(stderr,"arse no mem for styles !\n");
		exit(-1);
		}
	
	for (m=0;m<nostyles;m++)
		{
		cb = read_16ubit(tablefd);
		error(stderr,"size of std %ld\n",cb);

		stylelist[m].thepap.istd = 0;
		stylelist[m].thepap.fInTable = 0;
		stylelist[m].thepap.fTtp= 0;
		stylelist[m].thepap.ilvl = -1;
		stylelist[m].thepap.ilfo = -1; /*index into hpllfo*/
		stylelist[m].thepap.list_data = NULL; /*index into hpllfo*/
		
	
		init_chp(&stylelist[m].thechp);
		
		error(stderr,"m val is %d\n",m);

		if (cb != 0)
			{
			pos=0;

			read_16ubit(tablefd);
			pos+=2;
			j = read_16ubit(tablefd);
			pos+=2;
			baseistd = j>>4;
			error(stderr,"based upon istd is %d %d",j,baseistd);
			if (baseistd < 0x0ffe)
				fill_pap(stylelist,m,baseistd);
			else
				error(stderr,"WARNING strange and unsupported istd base %x\n",baseistd);
			j = read_16ubit(tablefd);
			pos+=2;
			error(stderr,"# of upx is %d %d\n",j,j>>12); 
			upxbytes = j;
			for (i=0;i<2;i++)
				{
				read_16ubit(tablefd);
				pos+=2;
				}
			len = read_16ubit(tablefd);
			pos+=2;
			error(stderr,"name len is %d,\n",len);
			for(i=0;i<len+1;i++)
				{
				thingy = read_16ubit(tablefd);
				pos+=2;
				error(stderr,"thingy is %ld (%X) (-%x-) (-%c-)\n",thingy,thingy,thingy,thingy);
				}

			error(stderr,"pos is %x and %d",ftell(tablefd),pos);
		if ((pos+1)/2 != pos/2)
			{
			/*eat odd bytes*/
			error(stderr,"odd offset\n");
			fseek(tablefd,1,SEEK_CUR);
			pos++;
			}

		if (pos == cb)
			{
			error(stderr,"continuing\n");
			continue;
			}
		else if (pos > cb)
			{
			error(stderr,"rewinding & continuing\n");
			fseek(tablefd,cb-pos,SEEK_CUR);
			continue;
			}
		if ((pos+1)/2 != pos/2)
			{
			/*eat odd bytes*/
			error(stderr,"odd offset\n");
			fseek(tablefd,1,SEEK_CUR);
			pos++;
			}

		if (pos == cb)
			{
			error(stderr,"continuing\n");
			continue;
			}
		else if (pos > cb)
			{
			error(stderr,"rewinding & continuing\n");
			fseek(tablefd,cb-pos,SEEK_CUR);
			continue;
			}

			/*read some kind of len variable, hairy territory again*/
			upxbytes = read_16ubit(tablefd);
			pos+=2;
			error(stderr,"1 eat %d bytes",upxbytes);
			j=0;
			if (upxbytes > 1)
				{
				tempistd = read_16ubit(tablefd);
				pos+=2;
				j+=2;
				if (tempistd != m)
					{
					error(stderr,"istds mismatch is %x %x\n",m,tempistd);
					/*treat it as a sprm instead*/
					sprm = tempistd;
					}
				else
					{
					if (j < upxbytes)
						{
						sprm = read_16ubit(tablefd);
						j+=2;
						pos+=2;
						}
					}
				}

			while (j<upxbytes)
				{
				error(stderr," j was %d\n",j);
				pos-=j;
				decode_sprm(tablefd,sprm,&(stylelist[m].thepap),&(stylelist[m].thechp),&j,NULL,stylelist,stylelist[m].thepap.istd);
				error(stderr," j is %d\n",j);
				pos+=j;
				if (j>=upxbytes)
					break;
				sprm = read_16ubit(tablefd);
				j+=2;
				pos+=2;
				}

		if ((pos+1)/2 != pos/2)
			{
			/*eat odd bytes*/
			error(stderr,"odd offset\n");
			fseek(tablefd,1,SEEK_CUR);
			error(stderr,"were at %x\n",ftell(tablefd));
			pos++;
			}

		if (pos == cb)
			{
			error(stderr,"continuing\n");
			continue;
			}
		else if (pos > cb)
			{
			error(stderr,"rewinding & continuing\n");
			fseek(tablefd,cb-pos,SEEK_CUR);
			continue;
			}
			/*then this is the len of bytes of the next stuff*/
			upxbytes = read_16ubit(tablefd);
			pos+=2;
			error(stderr,"2 eat %d bytes",upxbytes);

			/*k this is the good stuff*/
			j=0;
			while (j < upxbytes)
				{
				sprm = read_16ubit(tablefd);
				j+=2;
				pos+=2;
				error(stderr," j was %d\n",j);
				pos-=j;
				decode_sprm(tablefd,sprm,&(stylelist[m].thepap),&(stylelist[m].thechp),&j,NULL,stylelist,stylelist[m].thepap.istd);
				error(stderr," j is %d\n",j);
				pos+=j;
				}
			
			if ((pos+1)/2 != pos/2)
				{
				/*eat odd bytes*/
				error(stderr,"odd offset\n");
				fseek(tablefd,1,SEEK_CUR);
				pos++;
				}
			}
		}
	return(stylelist);
	}

void decode_field(FILE *main,field_info *magic_fields,long *cp,U8 *fieldwas,long *swallowcp1,long *swallowcp2)
	{
	time_t timep;
	struct tm *times;
	char date[1024];
	/*
	called at the start of a field, find the field associated
	with that cp and decode meaning, process to end of field
	*/

	/*wont deal with enbedded fields yet\n*/
	int i=0;
	int type=0;

	*swallowcp1 = -1;
	*swallowcp2 = -1;

	error(stderr,"decoding field with cp %x\n",*cp);

	if (magic_fields != NULL)
		{
		while(i<magic_fields->no+1)
			{
			error(stderr,"field entry says %d (%x)\n",i,magic_fields->cps[i]);
			if (magic_fields->cps[i] == *cp)
				{
				error(stderr,"found field entry at %d\n",i);
				type = (magic_fields->flds[i*2])&0x1f;
				error(stderr,"type is %d \n",type);
				break;
				}
			i++;
			}

		switch(type)
			{
			case 19:
				/*beggining a field*/
				*fieldwas = magic_fields->flds[(i*2)+1];
				switch (*fieldwas)
					{
					case 88:
						error(stderr,"HYPERLINK\n");
						printf("<a href=\"");
						*swallowcp1 = magic_fields->cps[i+1]-2;
						*swallowcp2 = magic_fields->cps[i+1];
						break;
					case 33:
						printf("%d",pagenumber);
						error(stderr,"pagenumber is now %d\n",pagenumber);
						break;
					case 26:
						printf("unknown # of pages");
						break;
					case 31:
						timep = time(NULL);
						times = localtime(&timep);
						strftime(date,1024,"%x",times);
						error(stderr,"output date as %s\n",date);
						printf("%s",date);
						break;
					case 32:
						timep = time(NULL);
						times = localtime(&timep);
						strftime(date,1024,"%X",times);
						error(stderr,"output time as %s\n",date);
						printf("%s",date);
						break;
					case 29:
						error(stderr,"spitting out original filename\n");
						break;
					case 13:
						error(stderr,"spitting out toc\n");
						break;
					default:
						error(stderr,"unsupported field %d\n",*fieldwas);
						break;
					}
				break;
			case 20:
				switch (*fieldwas)
					{
					case 26:
						break;
					case 88:
						error(stderr,"HYPERLINK middle\n");
						printf("\">");
						break;
					case 29:
						error(stderr,"filename middle\n");
						break;
					case 13:
						error(stderr,"toc middle\n");
						break;
					default:
						error(stderr,"unsupported field\n");
						break;
					}
				error(stderr,"field middle reached\n");
				break;
			case 21:
				switch (*fieldwas)
					{
					case 26:
						break;
					case 88:
						error(stderr,"HYPERLINK end\n");
						printf("</a>");
						break;
					default:
						error(stderr,"unsupported field\n");
						break;
					}
				error(stderr,"field end reached\n");
				break;
			default:
				error(stderr,"field wierdness!!\n");
				break;
			}
		}
	}


void chpsoff()
	{
	chps=1;
	}

void chpson()
	{
	chps=0;
	}

int decode_symbol(U16 fontspec)
	{
	error(stderr,"given symbol %ld, converting to %ld\n",fontspec,fontspec-61472);
	fontspec = fontspec-61472;
	if (fontspec < 95)
		fontspec+=34;
	printf("<img src=\"%s/%d.gif\">",symbolfontdir(),fontspec);
	return(1);
	}
	
char *symbolfontdir(void)
	{
	if (symbolurl != NULL)
		return(symbolurl);
	return(SYMBOLFONTDIR);
	}

int decode_wingding(U16 fontspec)
	{
	error(stderr,"given wingding %ld, converting to %ld\n",fontspec,fontspec-61472);
	fontspec = fontspec-61472;
	/*
	if (fontspec < 95)
	*/
	fontspec+=34;

	if (fontspec > 86) 
		fontspec+=4;

	if (fontspec == 114)
		fontspec = 153;
	else if (fontspec == 115)
		fontspec = 160;
	else if (fontspec == 116)
		fontspec = 163;
	else if (fontspec == 117)
		fontspec = 165;
	else if (fontspec == 118)
		fontspec = 164;
	else if (fontspec == 119)
		fontspec = 168;
	else if (fontspec == 120)
		fontspec = 167;
	else if (fontspec == 121)
		fontspec = 171;
	else if (fontspec == 122)
		fontspec = 172;
	else if (fontspec == 123)
		fontspec = 170;
	else if (fontspec == 124)
		fontspec = 184;
	else if (fontspec == 125)
		fontspec = 169;
	else if (fontspec == 129)
		fontspec = 116;
	else if (fontspec == 130)
		fontspec = 117;
	else if (fontspec == 131)
		fontspec = 114;
	else if (fontspec == 132)
		fontspec = 115;
	else if ( (fontspec > 132) && (fontspec < 156) )
		fontspec-=5;
	else if ( (fontspec >= 156) && (fontspec < 164 ) )
		fontspec-=38;
	else if (fontspec == 164)
		fontspec=151;
	else if (fontspec == 165)
		fontspec=152;
	else if (fontspec == 166)
		fontspec=161;
	else if  ((fontspec > 166) && (fontspec < 173 ) )
		fontspec-=13;
	else if (fontspec == 173)
		fontspec=162;
	else if (fontspec == 174)
		fontspec=164;
	else if ((fontspec > 174) && (fontspec < 186))
		fontspec-=2;
	else if ( (fontspec >= 186) && (fontspec < 257) )
		fontspec--;
	else if (fontspec > 256)
		fontspec-=170;
	
	printf("<img src=\"%s/%d.gif\">",wingdingfontdir(),fontspec);
	return(1);
	}
	
char *wingdingfontdir(void)
	{
	if (wingdingurl != NULL)
		return(wingdingurl);
	return(WINGDINGFONTDIR);
	}

U16 read_16ubit(FILE *in)
	{
	/*im pretty insecure when it come to dealing with bits, i like
	 *to address them by their meaning not the reality
	 */
	U8 temp1,temp2;
	U16 ret;
	temp1 = getc(in);
	temp2 = getc(in);
	ret = temp2;
	ret = ret << 8;
	ret += temp1;
	return(ret);
	}

U8 sgetc(U8 *in)
	{
	return(*in);
	}

U16 sread_16ubit(U8 *in)
	{
	U8 temp1,temp2;
	U16 ret;
	temp1 = *in;
	temp2 = *(in+1);
	ret = temp2;
	ret = ret << 8;
	ret += temp1;
	return(ret);
	}

U32 read_32ubit(FILE *in)
	{
	U16 temp1,temp2;
	U32 ret;
	temp1 = read_16ubit(in);
	temp2 = read_16ubit(in); 
	ret = temp2;
	ret = ret << 16;
	ret += temp1;
	return(ret);
	}

void oprintf(int silentflag,char *fmt, ...)
	{
    va_list argp;
	if (!silentflag)
		{
		va_start(argp, fmt);
		vfprintf(stdout, fmt, argp);
		va_end(argp);
		}
    }

void error(FILE *stream,char *fmt, ...)
	{
	#ifdef DEBUG
    va_list argp;
    fprintf(stream, "error: ");
    va_start(argp, fmt);
    vfprintf(stream, fmt, argp);
    va_end(argp);
    fprintf(stream, "\n");
	#endif
    }


RETSIGTYPE reaper (int ignored)
    {
#ifdef MUST_REINSTALL_SIGHANDLERS
    signal_handle (SIGCHLD, reaper);
#endif
    while (WAITPID (-1, 0, WNOHANG) > 0)
        ;

    }

RETSIGTYPE timeingout(int ignored)
    {
	printf("\nconversion took too long, assuming something wrong and aborting\n");
	printf("\ntimeout value higher (or dont set it) to try for longer\n");
	exit(-1);
    }

#if defined (HAVE_POSIX_SIGNALS)
void signal_handle (int sig, SigHandler * handler)
    {
    struct sigaction act, oact;

    act.sa_handler = handler;
    act.sa_flags = 0 | SA_NOCLDSTOP | SA_RESTART;
    sigemptyset (&act.sa_mask);
    sigemptyset (&oact.sa_mask);
    sigaction (sig, &act, &oact);
    }
#endif


